--*********************************
-- add tabs - each tab container has a table of criteria specifying which items are displayed in that tab. the criteria can be an itemUID, itemGID, categoryID, 
-- so, Tabs={}
-- -- Tab[1].Name=""
-- -- Tab[1].Criteria={}
-- -- Tab[1].Criteria[1].Type=1 -- ItemUID
-- -- Tab[1].Criteria[1].Value=0x1234567812345678 -- ItemUID
-- -- Tab[1].Criteria[2].Type=2 -- ItemGID
-- -- Tab[1].Criteria[2].Value=0x12345678 -- ItemGID
-- -- Tab[1].Criteria[3].Type=3 -- categoryID (from ItemCategory)
-- -- Tab[1].Criteria[3].Value=15 -- Turbine.Gameplay.ItemCategory.Oil
-- -- etc
-- in order to use tabs, we can NOT use the built in column functionality of the list (SetMaxColumns) as there is no way to specify that an item is a new row or occupies multiple columns
-- so we have to manage the rows and columns of the list manually :( blech

-- when bags are refreshed, each item is assigned a tab based on which "Tab" it matches BEST - matching based on ItemUID first, ItemGUI next, and categoryID last. if not found, then it goes into Tab[0] (or Tab[nil]) which is everything else (undefined)
-- when displaying, order based on tab then filter criteria, as tab value changes, display a header row
-- this probably requires a complete rebuild of the inventoryPanel, but at least inventoryPanel.ItemList
--*********************************

qtyDetail=Turbine.UI.ContextMenu()
-- this is the main display
--inventoryWindow=Turbine.UI.Lotro.Window();
function createInventoryWindow()
	inventoryWindow=nil -- incase this is a re-creation due to the SetSTretchMode(0) bug
	inventoryWindow=ZoomWindow()
	inventoryWindow:SetZoom(Settings.zoom)
	inventoryWindow.LeftMargin=5;
	inventoryWindow.TopMargin=140;
	inventoryWindow.BottomMargin=47;
	inventoryWindow:SetText("      "..Resource[language][2].."      ");
	inventoryWindow:SetVisible(not Settings.useMinimalHeader and not Settings.loadMinimized)
	inventoryWindow.MinimumWidth=Settings.panelMinWidth*displayWidth+inventoryWindow.LeftMargin*2
	inventoryWindow.MinimumHeight=Settings.panelMinHeight*displayHeight+inventoryWindow.TopMargin+inventoryWindow.BottomMargin
	local left=Settings.panelLeft*displayWidth-inventoryWindow.LeftMargin*Settings.zoom
	local top=Settings.panelTop*displayHeight-inventoryWindow.TopMargin*Settings.zoom
	if left<0 then left=0 end
	if top<0 then top=0 end
	inventoryWindow:SetPosition(left,top)
	inventoryWindow:SetResizable(true);
	inventoryWindow:SetSize(Settings.panelWidth*displayWidth+inventoryWindow.LeftMargin*2*Settings.zoom,Settings.panelHeight*displayHeight+(inventoryWindow.TopMargin+inventoryWindow.BottomMargin)*Settings.zoom);
	inventoryWindow.TitleIcon=Turbine.UI.Control();
	inventoryWindow.TitleIcon:SetParent(inventoryWindow);
	inventoryWindow.TitleIcon:SetSize(30,25);
	if language==1 then
		inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-104,5);
	elseif language==2 then
		inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-119,5);
	else
		inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-100,5);
	end
	inventoryWindow.TitleIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TitleIcon:SetBackground("GaranStuff/AltInventory/Resources/title_icon.tga");
	inventoryWindow.TitleIcon:SetMouseVisible(false);

	-- panel background
	inventoryWindow.TopPanelTiled=Turbine.UI.Control();
	inventoryWindow.TopPanelTiled:SetParent(inventoryWindow);
	inventoryWindow.TopPanelTiled:SetZOrder(-1);
	inventoryWindow.TopPanelTiled:SetSize(inventoryWindow:GetWidth()-30,111);
	inventoryWindow.TopPanelTiled:SetPosition(6,29);
	inventoryWindow.TopPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_toptiled_bw.jpg");
	inventoryWindow.TopPanelTiled:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.TopPanelTiled:SetBackColor(Settings.panelBackColor);
	inventoryWindow.TopPanelTiled:SetMouseVisible(false);

	inventoryWindow.TopPanelTiledTrim=Turbine.UI.Control();
	inventoryWindow.TopPanelTiledTrim:SetParent(inventoryWindow);
	inventoryWindow.TopPanelTiledTrim:SetZOrder(-1);
	inventoryWindow.TopPanelTiledTrim:SetSize(inventoryWindow:GetWidth()-30,4);
	inventoryWindow.TopPanelTiledTrim:SetPosition(6,136);
	inventoryWindow.TopPanelTiledTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelTiledTrim:SetBackground("GaranStuff/AltInventory/Resources/background_toptiled_trim.jpg");
	inventoryWindow.TopPanelTiledTrim:SetMouseVisible(false);

	inventoryWindow.TopPanelLeft=Turbine.UI.Control();
	inventoryWindow.TopPanelLeft:SetParent(inventoryWindow);
	inventoryWindow.TopPanelLeft:SetZOrder(-1);
	inventoryWindow.TopPanelLeft:SetSize(86,118);
	inventoryWindow.TopPanelLeft:SetPosition(5,22);
	inventoryWindow.TopPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_top_left.tga");
	inventoryWindow.TopPanelLeft:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.TopPanelLeft:SetBackColor(Settings.panelBackColor);
	inventoryWindow.TopPanelLeft:SetMouseVisible(false);

	inventoryWindow.TopPanelLeftTrim=Turbine.UI.Control();
	inventoryWindow.TopPanelLeftTrim:SetParent(inventoryWindow);
	inventoryWindow.TopPanelLeftTrim:SetZOrder(-1);
	inventoryWindow.TopPanelLeftTrim:SetSize(86,118);
	inventoryWindow.TopPanelLeftTrim:SetPosition(5,22);
	inventoryWindow.TopPanelLeftTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelLeftTrim:SetBackground("GaranStuff/AltInventory/Resources/background_top_left_trim.tga");
	inventoryWindow.TopPanelLeftTrim:SetMouseVisible(false);

	inventoryWindow.TopPanelCenter=Turbine.UI.Control();
	inventoryWindow.TopPanelCenter:SetParent(inventoryWindow);
	inventoryWindow.TopPanelCenter:SetSize(382,106);
	inventoryWindow.TopPanelCenter:SetPosition((inventoryWindow:GetWidth()-inventoryWindow.TopPanelCenter:GetWidth())/2-3,30);
	inventoryWindow.TopPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_top_center.tga");
	inventoryWindow.TopPanelCenter:SetMouseVisible(false);

	inventoryWindow.TopPanelRight=Turbine.UI.Control();
	inventoryWindow.TopPanelRight:SetParent(inventoryWindow);
	inventoryWindow.TopPanelRight:SetZOrder(-1);
	inventoryWindow.TopPanelRight:SetSize(86,118);
	inventoryWindow.TopPanelRight:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.TopPanelRight:GetWidth()-5,22);
	inventoryWindow.TopPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_top_right.tga");
	inventoryWindow.TopPanelRight:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.TopPanelRight:SetBackColor(Settings.panelBackColor);
	inventoryWindow.TopPanelRight:SetMouseVisible(false);

	inventoryWindow.TopPanelRightTrim=Turbine.UI.Control();
	inventoryWindow.TopPanelRightTrim:SetParent(inventoryWindow);
	inventoryWindow.TopPanelRightTrim:SetZOrder(-1);
	inventoryWindow.TopPanelRightTrim:SetSize(86,118);
	inventoryWindow.TopPanelRightTrim:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.TopPanelRightTrim:GetWidth()-5,22);
	inventoryWindow.TopPanelRightTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.TopPanelRightTrim:SetBackground("GaranStuff/AltInventory/Resources/background_top_right_trim.tga");
	inventoryWindow.TopPanelRightTrim:SetMouseVisible(false);

	inventoryWindow.CloseButton=Turbine.UI.Control();
	inventoryWindow.CloseButton:SetParent(inventoryWindow);
	inventoryWindow.CloseButton:SetSize(16,16);
	inventoryWindow.CloseButton:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.CloseButton:GetWidth()-6,21);
	inventoryWindow.CloseButton:SetBackground(0x41000196);
	inventoryWindow.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.CloseButton.MouseEnter=function()
		inventoryWindow.CloseButton:SetBackground(0x41000198);
	end
	inventoryWindow.CloseButton.MouseLeave=function()
		inventoryWindow.CloseButton:SetBackground(0x41000196);
	end
	inventoryWindow.CloseButton.MouseDown=function()
		inventoryWindow.CloseButton:SetBackground(0x41000197);
	end
	inventoryWindow.CloseButton.MouseClick=function()
		inventoryWindow:Close();
		if Settings.showIcon then
			iconWindow:SetVisible(true);
		end
	end

	inventoryWindow.CapacityPanel={};
	inventoryWindow.CapacityPanel=Turbine.UI.Control();
	inventoryWindow.CapacityPanel:SetParent(inventoryWindow);
	inventoryWindow.CapacityPanel.MaxWidth=376;
	inventoryWindow.CapacityPanel:SetPosition((inventoryWindow:GetWidth()-inventoryWindow.CapacityPanel.MaxWidth)/2,65);
	inventoryWindow.CapacityPanel:SetSize(inventoryWindow.CapacityPanel.MaxWidth,17);
	inventoryWindow.CapacityEmpty=Turbine.UI.Label();
	inventoryWindow.CapacityEmpty:SetParent(inventoryWindow);
	inventoryWindow.CapacityEmpty:SetPosition(inventoryWindow.CapacityPanel:GetLeft()+3,64);
	inventoryWindow.CapacityEmpty:SetSize(60,20);
	inventoryWindow.CapacityEmpty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	inventoryWindow.CapacityEmpty:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	inventoryWindow.CapacityEmpty:SetForeColor(Turbine.UI.Color(.2,1,.2));
	inventoryWindow.CapacityEmpty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.CapacityEmpty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	inventoryWindow.CapacityEmpty:SetText(Resource[language][4]);
	inventoryWindow.CapacityDisplay=Turbine.UI.Label();
	inventoryWindow.CapacityDisplay:SetParent(inventoryWindow);
	inventoryWindow.CapacityDisplay:SetSize(368,20);
	inventoryWindow.CapacityDisplay:SetPosition((inventoryWindow:GetWidth()-inventoryWindow.CapacityDisplay:GetWidth())/2,64);
	inventoryWindow.CapacityDisplay:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	inventoryWindow.CapacityDisplay:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	inventoryWindow.CapacityDisplay:SetForeColor(fontColor);
	inventoryWindow.CapacityDisplay:SetOutlineColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.CapacityDisplay:SetFontStyle(Turbine.UI.FontStyle.Outline);
	inventoryWindow.CapacityDisplay:SetText(Resource[language][5]);
	inventoryWindow.CapacityFull=Turbine.UI.Label();
	inventoryWindow.CapacityFull:SetParent(inventoryWindow);
	inventoryWindow.CapacityFull:SetSize(60,20);
	inventoryWindow.CapacityFull:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.CapacityEmpty:GetLeft()-66,64);
	inventoryWindow.CapacityFull:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);
	inventoryWindow.CapacityFull:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	inventoryWindow.CapacityFull:SetForeColor(Turbine.UI.Color(1,0,0));
	inventoryWindow.CapacityFull:SetOutlineColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.CapacityFull:SetFontStyle(Turbine.UI.FontStyle.Outline);
	inventoryWindow.CapacityFull:SetText(Resource[language][6]);

	inventoryWindow.CharCaption=Turbine.UI.Label();
	inventoryWindow.CharCaption:SetParent(inventoryWindow);
	inventoryWindow.CharCaption:SetSize(145,20);
	inventoryWindow.CharCaption:SetPosition(0,105);
	inventoryWindow.CharCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	inventoryWindow.CharCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	inventoryWindow.CharCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.CharCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	inventoryWindow.CharCaption:SetForeColor(Settings.fontColor);
	inventoryWindow.CharCaption:SetText(Resource[language][13]..":");
	inventoryWindow.CharList=DropDownList();
	inventoryWindow.CharList:SetParent(inventoryWindow);
	inventoryWindow.CharList:SetZOrder(1);
	inventoryWindow.CharList:SetSize(230,20);
	inventoryWindow.CharList:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	inventoryWindow.CharList:SetPosition(150,105);
	inventoryWindow.CharList:SetBackColor(backColor);
	inventoryWindow.CharList:SetCurrentBackColor(backColor);
	inventoryWindow.CharList:SetBorderColor(backColor);
	inventoryWindow.CharList.SelectedIndexChanged=function()
		if inventoryWindow.CharList:GetSelectedIndex()==1 then
			-- all display
			inventoryWindow.CapacityDisplay:SetText(Resource[language][10])
			inventoryWindow.CapacityPanel:SetVisible(false);
			equipmentPanel:SetVisible(false)
			inventoryPanel:SetVisible(true)
			inventoryPanel:Refresh();
			inventoryWindow.RemoveCharButton:SetVisible(false);
			minimalWindow.DelButton:SetVisible(false);
		elseif string.find(inventoryWindow.CharList:GetText(),"(EI)") ~=nil then
			-- equipped items display
			inventoryWindow.CapacityDisplay:SetText(Resource[language][10])
			inventoryWindow.CapacityPanel:SetVisible(false);
			inventoryPanel:SetVisible(false)
			equipmentPanel:SetVisible(true)
			equipmentPanel:Refresh()
			inventoryWindow.RemoveCharButton:SetVisible(false);
			minimalWindow.DelButton:SetVisible(false);
		else
			-- bags, vault, or shared storage display
			local filled,capacity
			if inventoryWindow.CharList:GetSelectedIndex()==2 then
				filled=tonumber(CharList["Shared Storage"].used);
				capacity=tonumber(CharList["Shared Storage"].capacity);
				inventoryWindow.RemoveCharButton:SetVisible(false);
				minimalWindow.DelButton:SetVisible(false);
			else
				filled=nil
				if CharList[inventoryWindow.CharList:GetText()].used~=nil then
					filled=tonumber(CharList[inventoryWindow.CharList:GetText()].used)
				end
				capacity=nil
				if CharList[inventoryWindow.CharList:GetText()].capacity~=nil then
					capacity=tonumber(CharList[inventoryWindow.CharList:GetText()].capacity)
				end
				local char=inventoryWindow.CharList:GetText();
				if char~=charName and string.find(char,"(Vault)")==nil then
					inventoryWindow.RemoveCharButton:SetVisible(true);
					minimalWindow.DelButton:SetVisible(true);
				else
					inventoryWindow.RemoveCharButton:SetVisible(false);
					minimalWindow.DelButton:SetVisible(false);
				end
			end
			inventoryWindow.CapacityDisplay:SetText(Resource[language][5].." ("..tostring(filled).."/"..tostring(capacity)..")")
			if filled==nil then filled=0 end
			if capacity==nil then capacity=1 end
			inventoryWindow.CapacityPanel:SetSize(inventoryWindow.CapacityPanel.MaxWidth*(filled/capacity),17);
			inventoryWindow.CapacityPanel:SetBackColor(Turbine.UI.Color(0,.3,0))
			if (filled/capacity)>=.75 then
				inventoryWindow.CapacityPanel:SetBackColor(Turbine.UI.Color(.3,0,0))
			elseif (filled/capacity)>=.5 then
				inventoryWindow.CapacityPanel:SetBackColor(Turbine.UI.Color(.75,.65,0))
			end
			inventoryWindow.CapacityPanel:SetVisible(true);
			equipmentPanel:SetVisible(false)
			inventoryPanel:SetVisible(true)
			inventoryPanel:Refresh();
		end
		minimalWindow.CharText:SetText(Resource[language][13]..": "..inventoryWindow.CharList:GetText());
		ApplySearch();
	end
	inventoryWindow.RemoveCharButton=Turbine.UI.Control();
	inventoryWindow.RemoveCharButton:SetParent(inventoryWindow);
	inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharList:GetLeft()+inventoryWindow.CharList:GetWidth()+12,inventoryWindow.CharList:GetTop());
	inventoryWindow.RemoveCharButton:SetSize(20,20);
	inventoryWindow.RemoveCharButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	inventoryWindow.RemoveCharButton:SetVisible(false);
	inventoryWindow.RemoveCharButton.MouseEnter = function()
		inventoryWindow.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull_hover.tga");
	end
	inventoryWindow.RemoveCharButton.MouseLeave = function()
		inventoryWindow.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	end
	inventoryWindow.RemoveCharButton.MouseClick = function()
			-- display confirmation
		inventoryWindow:SetEnabled(false);
		inventoryPanel.RemoveConfirmation:SetPosition((inventoryPanel.RemoveConfirmation:GetParent():GetWidth()-inventoryPanel.RemoveConfirmation:GetWidth())/2,(inventoryPanel.RemoveConfirmation:GetParent():GetHeight()-inventoryPanel.RemoveConfirmation:GetHeight())/2);
		inventoryPanel.RemoveConfirmation:SetVisible(true);
	end

	inventoryWindow.BottomBack=Turbine.UI.Control()
	inventoryWindow.BottomBack:SetParent(inventoryWindow);
	inventoryWindow.BottomBack:SetSize(inventoryWindow:GetWidth()-20,40);
	inventoryWindow.BottomBack:SetPosition(10,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomBack:SetBackColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.BottomBack:SetMouseVisible(false);
	inventoryWindow.BottomPanelTiled=Turbine.UI.Control();
	inventoryWindow.BottomPanelTiled:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelTiled:SetSize(inventoryWindow:GetWidth()-20,40);
	inventoryWindow.BottomPanelTiled:SetPosition(10,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelTiled:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.BottomPanelTiled:SetBackColor(Settings.panelBackColor);
	inventoryWindow.BottomPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_tiled_bw.tga");
	inventoryWindow.BottomPanelTiled:SetMouseVisible(false);

	inventoryWindow.BottomPanelTiledTrim=Turbine.UI.Control()
	inventoryWindow.BottomPanelTiledTrim:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelTiledTrim:SetSize(inventoryWindow:GetWidth()-20,5);
	inventoryWindow.BottomPanelTiledTrim:SetPosition(10,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelTiledTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_tiled_trim.tga");
	inventoryWindow.BottomPanelTiledTrim:SetMouseVisible(false);

	inventoryWindow.BottomPanelLeft=Turbine.UI.Control();
	inventoryWindow.BottomPanelLeft:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelLeft:SetSize(151,40);
	inventoryWindow.BottomPanelLeft:SetPosition(5,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelLeft:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.BottomPanelLeft:SetBackColor(Settings.panelBackColor);
	inventoryWindow.BottomPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_left.tga");
	inventoryWindow.BottomPanelLeft:SetMouseVisible(false);

	inventoryWindow.BottomPanelLeftTrim=Turbine.UI.Control();
	inventoryWindow.BottomPanelLeftTrim:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelLeftTrim:SetSize(151,40);
	inventoryWindow.BottomPanelLeftTrim:SetPosition(5,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelLeftTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelLeftTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_left_trim.tga");
	inventoryWindow.BottomPanelLeftTrim:SetMouseVisible(false);

	inventoryWindow.BottomPanelCenter=Turbine.UI.Control();
	inventoryWindow.BottomPanelCenter:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelCenter:SetSize(121,40);
	inventoryWindow.BottomPanelCenter:SetPosition((inventoryWindow:GetWidth()-inventoryWindow.BottomPanelCenter:GetWidth())/2+1,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_center.tga");
	inventoryWindow.BottomPanelCenter:SetMouseVisible(false);

	inventoryWindow.BottomPanelRight=Turbine.UI.Control();
	inventoryWindow.BottomPanelRight:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelRight:SetSize(151,40);
	inventoryWindow.BottomPanelRight:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRight:GetWidth()-4,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelRight:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
	inventoryWindow.BottomPanelRight:SetBackColor(Settings.panelBackColor);
	inventoryWindow.BottomPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_right.tga");
	inventoryWindow.BottomPanelRight:SetMouseVisible(false);

	inventoryWindow.BottomPanelRightTrim=Turbine.UI.Control();
	inventoryWindow.BottomPanelRightTrim:SetParent(inventoryWindow);
	inventoryWindow.BottomPanelRightTrim:SetSize(151,40);
	inventoryWindow.BottomPanelRightTrim:SetPosition(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRight:GetWidth()-4,inventoryWindow:GetHeight()-inventoryWindow.BottomMargin);
	inventoryWindow.BottomPanelRightTrim:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.BottomPanelRightTrim:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_right_trim.tga");
	inventoryWindow.BottomPanelRightTrim:SetMouseVisible(false);

	inventoryWindow.OptionsButton=Turbine.UI.Control();
	inventoryWindow.OptionsButton:SetParent(inventoryWindow);
	inventoryWindow.OptionsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	inventoryWindow.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	inventoryWindow.OptionsButton:SetSize(32,32);
	inventoryWindow.OptionsButton:SetTop(inventoryWindow.BottomPanelLeft:GetTop()+6);
	inventoryWindow.OptionsButton:SetLeft(inventoryWindow.BottomPanelLeft:GetLeft()+25);
	inventoryWindow.OptionsButton.MouseEnter = function()
		inventoryWindow.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options_hover.tga");
	end
	inventoryWindow.OptionsButton.MouseLeave = function()
		inventoryWindow.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	end
	inventoryWindow.OptionsButton.MouseClick=function()
		setupWindow:SetVisible(true);
		setupWindow:Refresh();
	end
	inventoryWindow.Message=Turbine.UI.Label();
	inventoryWindow.Message:SetParent(inventoryWindow);
	inventoryWindow.Message:SetZOrder(1);
	inventoryWindow.Message:SetSize(inventoryWindow:GetWidth()-inventoryWindow.OptionsButton:GetLeft()-inventoryWindow.OptionsButton:GetWidth()-40,40);
	inventoryWindow.Message:SetPosition(inventoryWindow.OptionsButton:GetLeft()+inventoryWindow.OptionsButton:GetWidth()+5,inventoryWindow.OptionsButton:GetTop())
	inventoryWindow.Message:SetForeColor(Turbine.UI.Color(1,0,0));
	inventoryWindow.Message:SetOutlineColor(Turbine.UI.Color(0,0,0));
	inventoryWindow.Message:SetFontStyle(Turbine.UI.FontStyle.Outline);

	inventoryWindow.SizeChanged=function()
		if not inventoryWindow.InSizeChanged then
			if Settings.zoom==1 and not inventoryWindow.InSizeChanged then
				inventoryWindow.InSizeChanged=true
				-- might have been externally triggered by resizing, set the width and height just in case
				inventoryWindow:SetSize(Turbine.UI.Lotro.Window.GetSize(inventoryWindow))
				inventoryWindow.InSizeChanged=false
			end
			local width,height=inventoryWindow:GetSize();
			Settings.panelWidth=(inventoryWindow:GetActualWidth()-inventoryWindow.LeftMargin*2*Settings.zoom)/displayWidth
			Settings.panelHeight=(inventoryWindow:GetActualHeight()-(inventoryWindow.TopMargin+inventoryWindow.BottomMargin)*Settings.zoom)/displayHeight
	
			inventoryWindow.BottomPanelTiled:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelTiledTrim:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomBack:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelLeft:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelLeftTrim:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelCenter:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelRight:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.BottomPanelRightTrim:SetTop(height-inventoryWindow.BottomMargin);
			inventoryWindow.OptionsButton:SetTop(inventoryWindow.BottomPanelLeft:GetTop()+6);
			inventoryWindow.Message:SetWidth(inventoryWindow:GetWidth()-inventoryWindow.OptionsButton:GetLeft()-inventoryWindow.OptionsButton:GetWidth()-40);
			inventoryWindow.Message:SetTop(inventoryWindow.OptionsButton:GetTop())
			if language==1 then
				inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-104,5);
			elseif language==2 then
				inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-119,5);
			else
				inventoryWindow.TitleIcon:SetPosition(inventoryWindow:GetWidth()/2-100,5);
			end
			inventoryWindow.TopPanelTiled:SetWidth(width-30);
			inventoryWindow.TopPanelTiledTrim:SetWidth(width-30);
			inventoryWindow.TopPanelCenter:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.TopPanelCenter:GetWidth())/2-3);
			inventoryWindow.TopPanelRight:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.TopPanelRight:GetWidth()-5);
			inventoryWindow.TopPanelRightTrim:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.TopPanelRightTrim:GetWidth()-5);
			inventoryWindow.CloseButton:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.CloseButton:GetWidth()-6);
			inventoryWindow.RemoveCharButton:SetLeft(inventoryWindow.CharList:GetLeft()+inventoryWindow.CharList:GetWidth()+12);
			inventoryWindow.CapacityPanel:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.CapacityPanel.MaxWidth)/2);
			inventoryWindow.CapacityEmpty:SetLeft(inventoryWindow.CapacityPanel:GetLeft()+3)
			inventoryWindow.CapacityFull:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.CapacityEmpty:GetLeft()-inventoryWindow.CapacityFull:GetWidth()-6,64)
			inventoryWindow.CapacityDisplay:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.CapacityDisplay:GetWidth())/2)

			inventoryWindow.BottomPanelTiled:SetWidth(inventoryWindow:GetWidth()-20);
			inventoryWindow.BottomPanelTiledTrim:SetWidth(inventoryWindow:GetWidth()-20);
			inventoryWindow.BottomBack:SetWidth(inventoryWindow:GetWidth()-20);
			inventoryWindow.BottomPanelCenter:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.BottomPanelCenter:GetWidth())/2+1);
			inventoryWindow.BottomPanelRight:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRight:GetWidth()-4);
			inventoryWindow.BottomPanelRightTrim:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRightTrim:GetWidth()-4);

			inventoryPanel:Layout()
			equipmentPanel:Layout()
		end
	end
end
createInventoryWindow()
function createMinimalWindow()
	minimalWindow=nil
	-- this is the "minimal" display
	minimalWindow=ZoomBasicWindow();
	minimalWindow:SetZoom(Settings.zoom)
	minimalWindow:SetVisible(Settings.useMinimalHeader and not Settings.loadMinimized)
	minimalWindow:SetBackColor(Settings.backColor);
	minimalWindow.LeftMargin=3;
	minimalWindow.TopMargin=20;
	minimalWindow.BottomMargin=3;
	minimalWindow.minimumWidth=Settings.panelMinWidth*displayWidth+minimalWindow.LeftMargin*2;
	minimalWindow.minimumHeight=Settings.panelMinHeight*displayHeight+minimalWindow.TopMargin+minimalWindow.BottomMargin;
	minimalWindow:SetSize(Settings.panelWidth*displayWidth+minimalWindow.LeftMargin*2*Settings.zoom,Settings.panelHeight*displayHeight+(minimalWindow.TopMargin+minimalWindow.BottomMargin)*Settings.zoom);
	local top=Settings.panelTop*displayHeight-minimalWindow.TopMargin*Settings.zoom
	local left=Settings.panelLeft*displayWidth-minimalWindow.LeftMargin*Settings.zoom
	if left<0 then left=0 end
	if top<0 then top=0 end
	minimalWindow:SetPosition(left,top)
	minimalWindow.CharMenu=Turbine.UI.ContextMenu();
	minimalWindow.MoveLabel=Turbine.UI.Label();
	minimalWindow.MoveLabel:SetParent(minimalWindow);
	minimalWindow.MoveLabel:SetMouseVisible(false);
	minimalWindow.MoveLabel:SetFont(Turbine.UI.Lotro.Font.Arial12)
	minimalWindow.MoveLabel:SetText("<>");
	minimalWindow.CharText=Turbine.UI.Label();
	minimalWindow.CharText:SetParent(minimalWindow);
	minimalWindow.CharText:SetSize(minimalWindow:GetWidth()-280,20);
	minimalWindow.CharText:SetPosition(140,0);
	minimalWindow.CharText:SetForeColor(Settings.fontColor);
	minimalWindow.CharText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	minimalWindow.CharText:SetText(Resource[language][13]..": "..charName);

	minimalWindow.CharText.MouseClick=function()
		minimalWindow.CharMenu:ShowMenu();
	end
	minimalWindow.DelButton=Turbine.UI.Label();
	minimalWindow.DelButton:SetParent(minimalWindow);
	minimalWindow.DelButton:SetSize(20,20);
	minimalWindow.DelButton:SetPosition(minimalWindow:GetWidth()-120,0);
	minimalWindow.DelButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga")
	minimalWindow.DelButton.MouseEnter = function()
		minimalWindow.DelButton:SetBackground("GaranStuff/AltInventory/Resources/skull_hover.tga");
	end
	minimalWindow.DelButton.MouseLeave = function()
		minimalWindow.DelButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	end

	minimalWindow.DelButton.MouseClick=function()
		inventoryWindow.RemoveCharButton:MouseClick();
	end

	minimalWindow.OptionsButton=Turbine.UI.Label();
	minimalWindow.OptionsButton:SetParent(minimalWindow);
	minimalWindow.OptionsButton:SetSize(100,20);
	minimalWindow.OptionsButton:SetPosition(minimalWindow:GetWidth()-minimalWindow.OptionsButton:GetWidth(),0);
	minimalWindow.OptionsButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	minimalWindow.OptionsButton:SetText(Resource[language][48]);
	minimalWindow.OptionsButton.MouseClick=function()
		setupWindow:SetVisible(true);
		setupWindow:Refresh();
	end

	minimalWindow.CloseButton=Turbine.UI.Label();
	minimalWindow.CloseButton:SetParent(minimalWindow);
	minimalWindow.CloseButton:SetSize(16,16);
	minimalWindow.CloseButton:SetPosition(minimalWindow:GetWidth()-18,2);
	minimalWindow.CloseButton:SetBackground(0x41000196)
	minimalWindow.CloseButton.MouseEnter=function()
		minimalWindow.CloseButton:SetBackground(0x41000198);
	end
	minimalWindow.CloseButton.MouseLeave=function()
		minimalWindow.CloseButton:SetBackground(0x41000196);
	end
	minimalWindow.CloseButton.MouseDown=function()
		minimalWindow.CloseButton:SetBackground(0x41000197);
	end
	minimalWindow.CloseButton.MouseClick=function()
		minimalWindow:Close();
		if Settings.showIcon then
			iconWindow:SetVisible(true);
		end
	end

	minimalWindow.Moving=false;
	minimalWindow.MovingIcon=Turbine.UI.Control();
	minimalWindow.MovingIcon:SetParent(minimalWindow);
	minimalWindow.MovingIcon:SetSize(32,32);
	minimalWindow.MovingIcon:SetBackground(0x410081c0)
	minimalWindow.MovingIcon:SetStretchMode(1);
	-- for some reason, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	minimalWindow.MovingIcon:SetPosition(minimalWindow:GetWidth()/2-15,minimalWindow:GetHeight()-21);
	minimalWindow.MovingIcon:SetVisible(false);

-- old sizing stuff - keeping this for now since it probably works better than the generic AND includes a Move feature. just need to tie it into the overridden SetSize
	minimalWindow.SizingV=false
	minimalWindow.SizingH=false
	minimalWindow.MouseDown=function(sender,args)
		minimalWindow.StartX=args.X;
		minimalWindow.StartY=args.Y;
		if (args.Y<16) then
			-- moving
			minimalWindow.Moving=true
			minimalWindow.MovingIcon:SetLeft(args.X-12);
			minimalWindow.MovingIcon:SetTop(args.Y-12);
			minimalWindow.MovingIcon:SetSize(32,32);
			minimalWindow.MovingIcon:SetBackground(0x410000dd)
			minimalWindow.MovingIcon:SetVisible(true);
		else
			if minimalWindow:IsAltKeyDown() or minimalWindow:IsShiftKeyDown() or minimalWindow:IsControlKeyDown() then
				minimalWindow.StartH=minimalWindow:GetActualWidth()
				minimalWindow.StartV=minimalWindow:GetActualHeight()
				if (args.Y>minimalWindow:GetHeight()-15) and (args.X>minimalWindow:GetWidth()-15) then
					-- diagonal sizing
					minimalWindow.SizingV=true
					minimalWindow.SizingH=true
					minimalWindow.MovingIcon:SetLeft(args.X-12);
					minimalWindow.MovingIcon:SetTop(args.Y-12);
					minimalWindow.MovingIcon:SetSize(32,32);
					minimalWindow.MovingIcon:SetBackground(0x41007e20)
					minimalWindow.MovingIcon:SetVisible(true);
				elseif (args.Y>minimalWindow:GetHeight()-12) then
					-- vertical sizing
					minimalWindow.SizingV=true
					minimalWindow.MoveY=args.Y;
					minimalWindow.MovingIcon:SetLeft(args.X-22);
					minimalWindow.MovingIcon:SetTop(args.Y-12);
					minimalWindow.MovingIcon:SetSize(32,32);
					minimalWindow.MovingIcon:SetBackground(0x410081c0)
					minimalWindow.MovingIcon:SetVisible(true);
				elseif (args.X>minimalWindow:GetWidth()-12) then
					-- horizontal sizing
					minimalWindow.SizingH=true
					minimalWindow.MoveX=args.X;
					minimalWindow.MovingIcon:SetLeft(args.X-12);
					minimalWindow.MovingIcon:SetTop(args.Y-22);
					minimalWindow.MovingIcon:SetSize(32,32);
					minimalWindow.MovingIcon:SetBackground(0x410081bf)
					minimalWindow.MovingIcon:SetVisible(true);
					minimalWindow.MoveX=-1;
					minimalWindow.MoveY=-1;
				end
			end
		end
	end

	minimalWindow.MouseMove=function(sender,args)
		if minimalWindow.Moving then
			local newLeft=minimalWindow:GetLeft()+(args.X-minimalWindow.StartX)*minimalWindow.Zoom
			local newTop=minimalWindow:GetTop()+(args.Y-minimalWindow.StartY)*minimalWindow.Zoom
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-minimalWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-minimalWindow:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-minimalWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-minimalWindow:GetHeight() end;
			minimalWindow:SetPosition(newLeft,newTop)		
		elseif minimalWindow.SizingV or minimalWindow.SizingH then
			local newHeight=minimalWindow:GetActualHeight()
			local newWidth=minimalWindow:GetActualWidth()
			if minimalWindow.SizingV then
				newHeight=minimalWindow.StartV+(args.Y-minimalWindow.StartY)*Settings.zoom
				if newHeight<minimalWindow:GetMinimumHeight() then newHeight=minimalWindow:GetMinimumHeight() end
				if newHeight>(Turbine.UI.Display.GetHeight()-minimalWindow:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-minimalWindow:GetTop() end;
				minimalWindow.MovingIcon:SetTop(args.Y-22)
			end
			if minimalWindow.SizingH then
				newWidth=minimalWindow.StartH+(args.X-minimalWindow.StartX)*Settings.zoom
				if newWidth<minimalWindow:GetMinimumWidth() then newWidth=minimumWindow:GetMinimumWidth() end
				if newWidth>(Turbine.UI.Display.GetWidth()-minimalWindow:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-minimalWindow:GetLeft() end;
				minimalWindow.MovingIcon:SetLeft(args.X-22)
			end
			minimalWindow:SetSize(newWidth,newHeight)
		end
	end
	minimalWindow.MouseUp=function(sender,args)
		minimalWindow.Moving=false
		minimalWindow.SizingV=false
		minimalWindow.SizingH=false
		minimalWindow.MovingIcon:SetVisible(false);
	end
	minimalWindow.SizeChanged=function()
		local width,height=minimalWindow:GetSize();
		Settings.panelWidth=(minimalWindow:GetActualWidth()-minimalWindow.LeftMargin*2*Settings.zoom)/displayWidth
		Settings.panelHeight=(minimalWindow:GetActualHeight()-(minimalWindow.TopMargin+minimalWindow.BottomMargin)*Settings.zoom)/displayHeight
		minimalWindow.OptionsButton:SetLeft(width-minimalWindow.OptionsButton:GetWidth()-20);
		minimalWindow.CharText:SetWidth(width-280);
		minimalWindow.DelButton:SetLeft(width-140);
		minimalWindow.CloseButton:SetLeft(width-18);
		inventoryPanel:Layout()
		equipmentPanel:Layout()
	end
end
createMinimalWindow()

--******************************************************************************
-- this is the main panel that displays the various inventories and is moved between the full window and the minimal window as needed
inventoryPanel=Turbine.UI.Control();
-- not sure this SetSize is even used. it doesn't account for Settings.zoom
inventoryPanel:SetSize(Settings.panelWidth*displayWidth,Settings.panelHeight*displayHeight)
if Settings.useMinimalHeader then
	inventoryPanel:SetParent(minimalWindow)
	inventoryPanel:SetPosition(minimalWindow.LeftMargin,minimalWindow.TopMargin)
else
	inventoryPanel:SetParent(inventoryWindow)
	inventoryPanel:SetPosition(inventoryWindow.LeftMargin,inventoryWindow.TopMargin)
end
inventoryPanel:SetMouseVisible(false)
inventoryPanelBack=Turbine.UI.Control()
inventoryPanelBack:SetParent(inventoryPanel)
inventoryPanelBack:SetBackground("GaranStuff/AltInventory/Resources/background_mid.jpg")
inventoryPanelBack:SetBlendMode(Turbine.UI.BlendMode.Overlay)
inventoryPanelBack:SetSize(inventoryWindow:GetWidth(),80)
inventoryPanelBack:SetMouseVisible(false)
inventoryPanel.FilterCaption=Turbine.UI.Label()
inventoryPanel.FilterCaption:SetParent(inventoryPanel)
inventoryPanel.FilterCaption:SetPosition(9,6)
inventoryPanel.FilterCaption:SetSize(70,20)
inventoryPanel.FilterCaption:SetFont(fontFace)
inventoryPanel.FilterCaption:SetForeColor(Settings.fontColor)
inventoryPanel.FilterCaption:SetOutlineColor(Turbine.UI.Color(0,0,0))
inventoryPanel.FilterCaption:SetFontStyle(Turbine.UI.FontStyle.Outline)
inventoryPanel.FilterCaption:SetText(Resource[language][11]..":")
inventoryPanel.FilterList=GaranStuff.AltInventory.DropDownList()
inventoryPanel.FilterList:SetParent(inventoryPanel)
inventoryPanel.FilterList:SetPosition(inventoryPanel.FilterCaption:GetLeft()+inventoryPanel.FilterCaption:GetWidth()+3,inventoryPanel.FilterCaption:GetTop()-3)
inventoryPanel.FilterList:SetSize(inventoryPanel:GetWidth()-(inventoryPanel.FilterCaption:GetWidth()+inventoryPanel.FilterCaption:GetLeft())-40,20)
inventoryPanel.FilterList:SetBorderColor(Settings.trimColor)
inventoryPanel.FilterList:SetBackColor(Settings.backColor)
inventoryPanel.FilterList:SetTextColor(Settings.listTextColor)
inventoryPanel.FilterList:SetCurrentBackColor(Settings.backColor)
inventoryPanel.FilterList:SetDropRows(6)
inventoryPanel.FilterList:SetZOrder(2)

inventoryPanel.FilterList:AddItem(Resource[language][12],-1)
for tmpIndex=1,#ItemCategory do
	if ItemCategory[tmpIndex][1]==Turbine.Gameplay.ItemCategory.Undefined then
		undefinedCategoryIndex=tmpIndex+1 -- need to keep track of where the "undefined" category winds up in the list
	end
	categorySortOrder[ItemCategory[tmpIndex][1]]=tmpIndex
	inventoryPanel.FilterList:AddItem(ItemCategory[tmpIndex][2][language],ItemCategory[tmpIndex][1])
end

inventoryPanel.FilterList.SelectedIndexChanged = function ()
	ApplySearch()
end

inventoryPanel.SearchCaption=Turbine.UI.Label();
inventoryPanel.SearchCaption:SetParent(inventoryPanel);
inventoryPanel.SearchCaption:SetPosition(9,31);
inventoryPanel.SearchCaption:SetSize(70,20);
inventoryPanel.SearchCaption:SetFont(fontFace);
inventoryPanel.SearchCaption:SetForeColor(Settings.fontColor);
inventoryPanel.SearchCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
inventoryPanel.SearchCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
inventoryPanel.SearchCaption:SetText(Resource[language][14]..":");

inventoryPanel.SearchBorder=Turbine.UI.Control();
inventoryPanel.SearchBorder:SetParent(inventoryPanel);
inventoryPanel.SearchBorder:SetPosition(inventoryPanel.SearchCaption:GetLeft()+inventoryPanel.SearchCaption:GetWidth()+2,inventoryPanel.SearchCaption:GetTop()-5);
inventoryPanel.SearchBorder:SetSize(inventoryPanel:GetWidth()/2-(inventoryPanel.SearchCaption:GetWidth()+inventoryPanel.SearchCaption:GetLeft()),20);
inventoryPanel.SearchBorder:SetBackColor(Turbine.UI.Color(.15,.25,.45))

inventoryPanel.SearchText=Turbine.UI.Lotro.TextBox();
inventoryPanel.SearchText:SetParent(inventoryPanel);
inventoryPanel.SearchText:SetPosition(inventoryPanel.SearchCaption:GetLeft()+inventoryPanel.SearchCaption:GetWidth()+3,inventoryPanel.SearchCaption:GetTop()-4);
inventoryPanel.SearchText:SetSize(inventoryPanel.SearchBorder:GetWidth()-2,18);
inventoryPanel.SearchText:SetBackColor(Turbine.UI.Color(.25,.35,.55));
inventoryPanel.SearchText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
inventoryPanel.SearchText:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
inventoryPanel.SearchText:SetForeColor(Settings.fontColor);
inventoryPanel.SearchText:SetOutlineColor(Turbine.UI.Color(0,0,0));
inventoryPanel.SearchText:SetFontStyle(Turbine.UI.FontStyle.Outline);
inventoryPanel.SearchText:SetWantsUpdates(false);
inventoryPanel.SearchText.Text="";
inventoryPanel.SearchText.FocusGained=function()
	inventoryPanel.SearchText:SetWantsUpdates(true);
end
inventoryPanel.SearchText.FocusLost=function()
	inventoryPanel.SearchText:SetWantsUpdates(false);
end
inventoryPanel.SearchText.Update=function()
	if inventoryPanel.SearchText.Text~=inventoryPanel.SearchText:GetText() then
		inventoryPanel.SearchText.Text=inventoryPanel.SearchText:GetText()
		ApplySearch();
	end
end
function ApplySearch()
	if Settings.debug then
		Turbine.Shell.WriteLine("in ApplySearch")
	end
	local cmpText=string.lower(string.stripaccent(inventoryPanel.SearchText.Text))
	local index
	for index=1,inventoryPanel.ItemList:GetItemCount() do
		local tmpItem=inventoryPanel.ItemList:GetItem(index)
		local tmpHeight=inventoryPanel.EntryNormalHeight
		local forceSort=1
		local category=inventoryPanel.FilterList:GetValue()
		if category~=-1 and tmpItem.SortCategory~=category then
				tmpHeight=0
				forceSort=2
		elseif inventoryPanel.SearchText.Text~="" then
			success,result=pcall(string.find,string.lower(string.stripaccent(tmpItem.Name)),cmpText)
			if result==nil then
				tmpHeight=0
				forceSort=2
			end
		end
		tmpItem:SetHeight(tmpHeight)
		tmpItem.ForceSort=forceSort
	end
	inventoryPanel.SortList:SelectedIndexChanged(); -- reapply sort
end
inventoryPanel.ShowAllButton=Turbine.UI.Lotro.Button();
inventoryPanel.ShowAllButton:SetParent(inventoryPanel);
inventoryPanel.ShowAllButton:SetSize(120,18);
inventoryPanel.ShowAllButton:SetPosition(inventoryPanel.FilterList:GetLeft()+inventoryPanel.FilterList:GetWidth()-inventoryPanel.ShowAllButton:GetWidth(),inventoryPanel.SearchText:GetTop()-1);
inventoryPanel.ShowAllButton:SetText(Resource[language][23]);
inventoryPanel.ShowAllButton.Click=function()
	inventoryPanel.SearchText:SetWantsUpdates(false)
	inventoryPanel.SearchText:SetText("")
	inventoryPanel.SearchText.Text=""
	inventoryPanel.FilterList:SetSelectedIndex(1)
	inventoryPanel.FilterList:SelectedIndexChanged()
--	ApplySearch()
end

inventoryPanel.SortCaption=Turbine.UI.Label();
inventoryPanel.SortCaption:SetParent(inventoryPanel);
inventoryPanel.SortCaption:SetPosition(9,54);
inventoryPanel.SortCaption:SetSize(70,20);
inventoryPanel.SortCaption:SetFont(fontFace);
inventoryPanel.SortCaption:SetForeColor(Settings.fontColor);
inventoryPanel.SortCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
inventoryPanel.SortCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
inventoryPanel.SortCaption:SetText(Resource[language][15]..":");

inventoryPanel.SortList=DropDownList();
inventoryPanel.SortList:SetParent(inventoryPanel);
inventoryPanel.SortList:SetPosition(inventoryPanel.SortCaption:GetLeft()+inventoryPanel.SortCaption:GetWidth()+3,inventoryPanel.SortCaption:GetTop()-3);
inventoryPanel.SortList:SetSize(inventoryPanel:GetWidth()/2-(inventoryPanel.SortCaption:GetWidth()+inventoryPanel.SortCaption:GetLeft())-1,20);
inventoryPanel.SortList:SetBorderColor(Settings.trimColor);
inventoryPanel.SortList:SetCurrentBackColor(colorDarkGrey);
inventoryPanel.SortList:SetBackColor(Settings.backColor);
inventoryPanel.SortList:SetTextColor(Settings.listTextColor);
inventoryPanel.SortList:SetCurrentBackColor(Settings.backColor);
inventoryPanel.SortList:SetDropRows(5);  -- increase as we implement the last 2 options
inventoryPanel.SortList:SetZOrder(1);
--inventoryPanel.SortList:AddItem(Resource[language][16],0); -- location in bag is no longer supported since the vault and shared storage do not support this
inventoryPanel.SortList:AddItem(Resource[language][17],1);
inventoryPanel.SortList:AddItem(Resource[language][18],2);
inventoryPanel.SortList:AddItem(Resource[language][19],3);
inventoryPanel.SortList:AddItem(Resource[language][20],4);
--inventoryPanel.SortList:AddItem(Resource[language][21],5); -- did this really serve any use other than a mildly interesting programming exercise?  nope.
inventoryPanel.SortList.SelectedIndexChanged=function()
-- there is a major bug in the ListBox:Sort() method which totally fouls up the internal indexing for the listbox entries
-- this requires the workaround below. if Turbine ever fixes the :Sort method then the workaround can be scrapped and :Sort reenabled
	local index=inventoryPanel.SortList:GetValue();
	if index==1 then
--		inventoryPanel.ItemList:Sort(function(arg1,arg2) if arg1.Name<arg2.Name then return true end end)
		inventoryPanel.ItemList:SortList(function(arg1,arg2) if arg1.ForceSort<arg2.ForceSort then return true elseif arg1.ForceSort==arg2.ForceSort and arg1.Name<arg2.Name then return true end end)
	elseif index==2 then
--		inventoryPanel.ItemList:Sort(function(arg1,arg2) if arg1.Name>arg2.Name then return true end end)
		inventoryPanel.ItemList:SortList(function(arg1,arg2) if arg1.ForceSort<arg2.ForceSort then return true elseif arg1.ForceSort==arg2.ForceSort and arg1.Name>arg2.Name then return true end end)
	elseif index==3 then
--		inventoryPanel.ItemList:Sort(function(arg1,arg2) if arg1.Category<arg2.Category then return true end end)
		for tmpIndex=1,inventoryPanel.ItemList:GetItemCount() do
			if categorySortOrder[inventoryPanel.ItemList:GetItem(tmpIndex).Category]==nil then
				-- set it to the same sort order as the Undefined category
				categorySortOrder[inventoryPanel.ItemList:GetItem(tmpIndex).Category]=categorySortOrder[Turbine.Gameplay.ItemCategory.Undefined];
			end
		end
		inventoryPanel.ItemList:SortList(function(arg1,arg2) if arg1.ForceSort<arg2.ForceSort then return true elseif arg1.ForceSort==arg2.ForceSort and categorySortOrder[arg1.Category]<categorySortOrder[arg2.Category] then return true elseif arg1.ForceSort==arg2.ForceSort and categorySortOrder[arg1.Category]==categorySortOrder[arg2.Category] and arg1.Name< arg2.Name then return true end end)
	else
--		inventoryPanel.ItemList:Sort(function(arg1,arg2) if arg1.Quality<arg2.Quality then return true end end)
		inventoryPanel.ItemList:SortList(function(arg1,arg2) if arg1.ForceSort<arg2.ForceSort then return true elseif arg1.ForceSort==arg2.ForceSort and arg1.Quality<arg2.Quality then return true elseif arg1.ForceSort==arg2.ForceSort and arg1.Quality==arg2.Quality and arg1.Name< arg2.Name then return true end end)
	end
end

inventoryPanel.DisplayCaption=Turbine.UI.Label();
inventoryPanel.DisplayCaption:SetParent(inventoryPanel);
inventoryPanel.DisplayCaption:SetPosition(inventoryPanel:GetWidth()/2+10,54);
inventoryPanel.DisplayCaption:SetSize(70,20);
inventoryPanel.DisplayCaption:SetFont(fontFace);
inventoryPanel.DisplayCaption:SetForeColor(Settings.fontColor);
inventoryPanel.DisplayCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
inventoryPanel.DisplayCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
inventoryPanel.DisplayCaption:SetText(Resource[language][22]..":");

inventoryPanel.EntryNormalWidth=185;
inventoryPanel.EntryWideWidth=370;
inventoryPanel.EntryNormalHeight=38;
inventoryPanel.DisplayMode1=Turbine.UI.Control();
inventoryPanel.DisplayMode1:SetParent(inventoryPanel);
inventoryPanel.DisplayMode1:SetPosition(inventoryPanel.DisplayCaption:GetLeft()+inventoryPanel.DisplayCaption:GetWidth()+10,52);
inventoryPanel.DisplayMode1:SetSize(19,19);
inventoryPanel.DisplayMode1.MouseClick=function()
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
	Settings.panelViewMode=1;
	local index;
	for index=1,inventoryPanel.ItemList:GetItemCount() do
		local item=inventoryPanel.ItemList:GetItem(index);
		item:SetWidth(inventoryPanel.EntryWideWidth);
		item.Back:SetWidth(inventoryPanel.EntryWideWidth-4);
		item.Text:SetWidth(inventoryPanel.EntryWideWidth-58);
		item.Text:SetLeft(54);
		item.Text:SetVisible(true);
		item.IconBack:SetPosition(1,1);
		item.IconBack:SetVisible(false);
		item.Qty:SetParent(item.Back);
		item.Qty:SetSize(48,item.Text:GetHeight());
		item.Qty:SetTop(1);
		item.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		item.Qty:SetText(item.Qty:GetText())
	end
	inventoryPanel:Layout();
end

inventoryPanel.DisplayMode2=Turbine.UI.Control();
inventoryPanel.DisplayMode2:SetParent(inventoryPanel);
inventoryPanel.DisplayMode2:SetPosition(inventoryPanel.DisplayMode1:GetLeft()+inventoryPanel.DisplayMode1:GetWidth()+10,52);
inventoryPanel.DisplayMode2:SetSize(19,19);
inventoryPanel.DisplayMode2.MouseClick=function()
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
	Settings.panelViewMode=2;
	local index;
	for index=1,inventoryPanel.ItemList:GetItemCount() do
		local item=inventoryPanel.ItemList:GetItem(index);
		item:SetWidth(inventoryPanel.EntryNormalWidth);
		item.Back:SetWidth(inventoryPanel.EntryNormalWidth-4);
		item.Text:SetWidth(inventoryPanel.EntryNormalWidth-38);
		item.Text:SetLeft(34);
		item.Text:SetVisible(true);
		item.IconBack:SetPosition(1,1);
		item.IconBack:SetVisible(true);
		item.Qty:SetParent(item.Icon);
		item.Qty:SetSize(28,12);
		item.Qty:SetTop(16);
		local qty=tonumber(item.Qty:GetText());
		if qty==nil then qty=0 end
		if qty<10000 then
			item.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		else
			item.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana10);
		end
	end
	inventoryPanel:Layout();
end

inventoryPanel.DisplayMode3=Turbine.UI.Control();
inventoryPanel.DisplayMode3:SetParent(inventoryPanel);
inventoryPanel.DisplayMode3:SetPosition(inventoryPanel.DisplayMode2:GetLeft()+inventoryPanel.DisplayMode2:GetWidth()+10,52);
inventoryPanel.DisplayMode3:SetSize(19,19);
inventoryPanel.DisplayMode3.MouseClick=function()
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
	Settings.panelViewMode=3;
	local index;
	for index=1,inventoryPanel.ItemList:GetItemCount() do
		local item=inventoryPanel.ItemList:GetItem(index);
		item:SetWidth(inventoryPanel.EntryNormalHeight);
		item.Back:SetWidth(inventoryPanel.EntryNormalHeight-4);
		item.Text:SetVisible(false);
		item.IconBack:SetPosition(1,1);
		item.IconBack:SetVisible(true);
		item.Qty:SetParent(item.Icon);
		item.Qty:SetSize(28,12);
		item.Qty:SetTop(16);
		local qty=tonumber(item.Qty:GetText());
		if qty==nil then qty=0 end
		if qty<10000 then
			item.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		else
			item.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana10);
		end
	end
	inventoryPanel:Layout();
end

inventoryPanel.ItemList=Turbine.UI.ListBox()
inventoryPanel.ItemList:SetMouseVisible(false);
inventoryPanel.ItemList:SetParent(inventoryPanel)
inventoryPanel.ItemList:SetPosition(0,80);
-- this is the workaround for the built in ListBox:Sort() method that is buggy
inventoryPanel.ItemList.SortList=function(sender,sortFunct)
	-- sender will be inventoryPanel.ItemList
	-- sortFunct is a function which sorts a table of items
	local tmpTable={};
	local index;
	local tmpHandle;

	for index=1,inventoryPanel.ItemList:GetItemCount() do
		inventoryPanel.ItemList:GetItem(index).oldIndex=index
		tmpTable[index]=inventoryPanel.ItemList:GetItem(index)
	end
	table.sort(tmpTable,sortFunct)
	local dummy=Turbine.UI.Control() -- not sure we still need to use the placeholder
	if Settings.panelViewMode==3 then
		-- icon only
		dummy:SetSize(inventoryPanel.EntryNormalHeight,inventoryPanel.EntryNormalHeight);
	elseif Settings.paneViewMode==1 then
		dummy:SetSize(inventoryPanel.EntryWideWidth,inventoryPanel.EntryNormalHeight);
	else
		-- icon and text
		dummy:SetSize(inventoryPanel.EntryNormalWidth,inventoryPanel.EntryNormalHeight);
	end
	tmpHandle=1;
	index=1;
	-- using "for k,v in pairs" does not work - probably because we are manipulating the table as we iterate over it
	for index=1,#tmpTable do
		if inventoryPanel.ItemList:GetItem(index).Name~=tmpTable[index].Name then
			-- swap
			tmpHandle=inventoryPanel.ItemList:GetItem(index); -- grab a handle to the item that is in the index that we want the new tmpTable item to go
			tmpHandle.oldIndex=tmpTable[index].oldIndex;
			inventoryPanel.ItemList:SetItem(tmpTable[index].oldIndex,dummy) -- need to put a dummy at the old index so the table has the same number of elements when we move the item at tmpTable[index] to its new index
			inventoryPanel.ItemList:SetItem(index,tmpTable[index])
			inventoryPanel.ItemList:SetItem(tmpTable[index].oldIndex,tmpHandle)
			tmpHandle=nil;
		end
	end
end
inventoryPanel.VScroll=Turbine.UI.Lotro.ScrollBar()
inventoryPanel.VScroll:SetParent(inventoryPanel);
inventoryPanel.VScroll:SetSize(10,inventoryPanel.ItemList:GetHeight());
inventoryPanel.VScroll:SetPosition(inventoryPanel:GetWidth()-10,inventoryPanel.ItemList:GetTop());
inventoryPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
inventoryPanel.ItemList:SetVerticalScrollBar(inventoryPanel.VScroll);
inventoryPanel.ItemList:SetOrientation( Turbine.UI.Orientation.Horizontal )
inventoryPanel.ItemList:SetAllowDrop(true);
inventoryPanel.ItemList.DragDrop=function(sender,args)
	if inventoryWindow.CharList:GetText()==charName then
		local tmpIndex;
		local dropIndex;
		for tmpIndex=1,backPack:GetSize() do
			if backPack:GetItem(tmpIndex)==nil then
				dropIndex=tmpIndex;
				break
			end
		end
		if dropIndex==nil then
			inventoryWindow.Message:SetText(Resource[language][50])
		else
			backPack:PerformShortcutDrop(args.DragDropInfo:GetShortcut(),dropIndex);
		end
	else
		inventoryWindow.Message:SetText(Resource[language][51])
	end
end

if Settings.panelViewMode==3 then
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
elseif Settings.panelViewMode==2 then
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
else
	inventoryPanel.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
	inventoryPanel.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
	inventoryPanel.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
end
inventoryPanel.Layout=function()
	if debug then
		Turbine.Shell.WriteLine("in inventoryPanel.Layout")
	end
	local parent=inventoryPanel:GetParent()
	local width,height
	if parent.LeftMargin~=nil then
		width=parent:GetWidth()-parent.LeftMargin*2
		height=parent:GetHeight()-parent.TopMargin-parent.BottomMargin
	else
		width=parent:GetWidth()
		height=parent:GetHeight()
	end
	inventoryPanel:SetSize(width,height);
	inventoryPanelBack:SetWidth(width);
	local numColumns
	if Settings.panelViewMode==3 then
		inventoryPanel.ItemList.ColWidth=inventoryPanel.EntryNormalHeight
	elseif Settings.panelViewMode==1 then
		inventoryPanel.ItemList.ColWidth=inventoryPanel.EntryWideWidth
	else
		inventoryPanel.ItemList.ColWidth=inventoryPanel.EntryNormalWidth
	end
	numColumns=math.floor((inventoryPanel:GetWidth()-10)/inventoryPanel.ItemList.ColWidth)

	inventoryPanel.FilterList:SetWidth(width-inventoryPanel.FilterList:GetLeft()-37);
	inventoryPanel.SearchBorder:SetWidth(width/2-inventoryPanel.SearchBorder:GetLeft());
	inventoryPanel.SearchText:SetWidth(inventoryPanel.SearchBorder:GetWidth()-2);
	inventoryPanel.ShowAllButton:SetLeft(width*3/4-inventoryPanel.ShowAllButton:GetWidth()/2);
	inventoryPanel.SortList:SetWidth(width/2-inventoryPanel.SortList:GetLeft());
	inventoryPanel.DisplayCaption:SetLeft(width*3/4-(inventoryPanel.DisplayCaption:GetWidth()+30+inventoryPanel.DisplayMode1:GetWidth()*3)/2);
	inventoryPanel.DisplayMode1:SetLeft(inventoryPanel.DisplayCaption:GetLeft()+inventoryPanel.DisplayCaption:GetWidth()+10);
	inventoryPanel.DisplayMode2:SetLeft(inventoryPanel.DisplayMode1:GetLeft()+inventoryPanel.DisplayMode1:GetWidth()+10);
	inventoryPanel.DisplayMode3:SetLeft(inventoryPanel.DisplayMode2:GetLeft()+inventoryPanel.DisplayMode2:GetWidth()+10);
	inventoryPanel.ItemList:SetSize(inventoryPanel:GetWidth()-10,inventoryPanel:GetHeight()-inventoryPanelBack:GetHeight())
	inventoryPanel.VScroll:SetLeft(inventoryPanel:GetWidth()-10);
	inventoryPanel.VScroll:SetHeight(inventoryPanel.ItemList:GetHeight());
	inventoryPanel.ItemList:SetMaxColumns(numColumns)
end

inventoryPanel.RemoveConfirmation=Turbine.UI.Label();
inventoryPanel.RemoveConfirmation:SetParent(inventoryPanel);
inventoryPanel.RemoveConfirmation:SetSize(200,200);
inventoryPanel.RemoveConfirmation:SetPosition((inventoryWindow:GetWidth()-inventoryPanel.RemoveConfirmation:GetWidth())/2,(inventoryWindow:GetHeight()-inventoryPanel.RemoveConfirmation:GetHeight())/2);
inventoryPanel.RemoveConfirmation:SetBackColor(trimColor);
inventoryPanel.RemoveConfirmation:SetZOrder(2);
inventoryPanel.RemoveConfirmation.Text=Turbine.UI.Label();
inventoryPanel.RemoveConfirmation.Text:SetParent(inventoryPanel.RemoveConfirmation)
inventoryPanel.RemoveConfirmation.Text:SetSize(inventoryPanel.RemoveConfirmation:GetWidth()-2,inventoryPanel.RemoveConfirmation:GetHeight()-2);
inventoryPanel.RemoveConfirmation.Text:SetPosition(1,1);
inventoryPanel.RemoveConfirmation.Text:SetBackColor(backColor);
inventoryPanel.RemoveConfirmation.Text:SetForeColor(fontColor);
inventoryPanel.RemoveConfirmation.Text:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
inventoryPanel.RemoveConfirmation.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
inventoryPanel.RemoveConfirmation.Text:SetText(Resource[1][46]);
inventoryPanel.RemoveConfirmation.OK=Turbine.UI.Lotro.Button();
inventoryPanel.RemoveConfirmation.OK:SetParent(inventoryPanel.RemoveConfirmation.Text);
inventoryPanel.RemoveConfirmation.OK:SetSize(80,20);
inventoryPanel.RemoveConfirmation.OK:SetPosition(10,inventoryPanel.RemoveConfirmation.Text:GetHeight()-25);
inventoryPanel.RemoveConfirmation.OK:SetText(Resource[1][47]);
inventoryPanel.RemoveConfirmation.OK.Click=function()
	local name=inventoryWindow.CharList:GetText();
	local vaultName=name.." (Vault)";
	for k,v in pairs(accountItemQty) do
		local delElem=v.Qty[name];
		if delElem~=nil then
			if type(delElem)=="table" then
				if delElem.Subtotal~=nil then
					accountItemQty[k].Total=accountItemQty[k].Total-delElem.Subtotal;
				end
			else
				if delElem~=nil then
					accountItemQty[k].Total=accountItemQty[k].Total-delElem;
				end
			end
			accountItemQty[k].Qty[name]=nil;
		end
		delElem=v.Qty[vaultName];
		if delElem~=nil then
			if type(delElem)=="table" then
				if delElem.Subtotal~=nil then
					accountItemQty[k].Total=accountItemQty[k].Total-delElem.Subtotal;
				end
			else
				if delElem~=nil then
					accountItemQty[k].Total=accountItemQty[k].Total-delElem;
				end
			end
			accountItemQty[k].Qty[vaultName]=nil;
		end
	end
	inventoryWindow:SetEnabled(true);
	inventoryPanel.RemoveConfirmation:SetVisible(false);
	local index=inventoryWindow.CharList:GetSelectedIndex();
	inventoryWindow.CharList:RemoveItemAt(index);
	minimalWindow.CharMenu:GetItems():RemoveAt(index);
	CharList[name]=nil;
	local vaultIndex;
	for vaultIndex=3,inventoryWindow.CharList.ListData:GetItemCount() do
		if inventoryWindow.CharList.ListData:GetItem(vaultIndex):GetText()==vaultName then
			inventoryWindow.CharList:RemoveItemAt(vaultIndex);
			minimalWindow.CharMenu:GetItems():RemoveAt(vaultIndex);
			if vaultIndex>index then index=vaultIndex end -- shouldn't be possible
			break;
		end
	end
	CharList[vaultName]=nil;
	if index>inventoryWindow.CharList.ListData:GetItemCount() then index=inventoryWindow.CharList.ListData:GetItemCount() end
	inventoryWindow.CharList:SetSelectedIndex(index);
	inventoryWindow.CharList:SelectedIndexChanged();
end
inventoryPanel.RemoveConfirmation.Cancel=Turbine.UI.Lotro.Button();
inventoryPanel.RemoveConfirmation.Cancel:SetParent(inventoryPanel.RemoveConfirmation.Text);
inventoryPanel.RemoveConfirmation.Cancel:SetSize(80,20);
inventoryPanel.RemoveConfirmation.Cancel:SetPosition(inventoryPanel.RemoveConfirmation.Text:GetWidth()-inventoryPanel.RemoveConfirmation.Cancel:GetWidth()-10,inventoryPanel.RemoveConfirmation.Text:GetHeight()-25);
inventoryPanel.RemoveConfirmation.Cancel:SetText(Resource[1][37]);
inventoryPanel.RemoveConfirmation.Cancel.Click=function()
	inventoryWindow:SetEnabled(true);
	inventoryPanel.RemoveConfirmation:SetVisible(false);
	end
inventoryPanel.RemoveConfirmation:SetVisible(false);

inventoryPanel:Layout()

ItemEntry=class(Turbine.UI.Control)
function ItemEntry:Constructor(name,char,qty,itemInfo)
	Turbine.UI.Control.Constructor(self)
	self:SetParent(inventoryPanel.ItemList);
	self.FilteredHeight=inventoryPanel.EntryNormalHeight;
	self:SetBackColor(Turbine.UI.Color(.1,.15,.25));
	self.Back=Turbine.UI.Control();
	self.Back:SetParent(self);
	self.Back:SetPosition(2,2);
	self.Back:SetBackColor(Settings.backColor);
	self.Back:SetMouseVisible(false);
	self.Text=Turbine.UI.Label();
	self.Text:SetParent(self.Back);
	self.Text:SetForeColor(GetQualityColor(accountItemQty[name].Quality));
	self.Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.Text:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.Text:SetText(name);
	self.Text:SetMouseVisible(false);
	self.IconBack=Turbine.UI.Control();
	self.IconBack:SetParent(self.Back);
	self.IconBack:SetSize(32,32);
	self.IconBack:SetMouseVisible(false);

	self.ItemInfo=Turbine.UI.Lotro.ItemInfoControl();
	self.ItemInfo:SetParent(self.IconBack);
	self.ItemInfo:SetSize(32,32);
	self.ItemInfo:SetPosition(-3,-3);
	self.ItemInfo:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ItemInfo:SetMouseVisible(true);
	if itemInfo==nil then
		self.ItemInfo:SetMouseVisible(false);
	else
		self.ItemInfo:SetMouseVisible(true);
		self.ItemInfo:SetItemInfo(itemInfo);
	end
	self.Icon=Turbine.UI.Control();
	self.Icon:SetParent(self.IconBack);
	self.Icon:SetSize(32,32);
	self.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.Icon:SetBackground(accountItemQty[name].IconImageID);
	self.Icon:SetMouseVisible(false);
	self.Icon:SetZOrder(1);
	self.IconBorder=Turbine.UI.Control();
	self.IconBorder:SetParent(self.Icon);
	self.IconBorder:SetSize(32,32);
	self.IconBorder:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.IconBorder:SetBackground("GaranStuff/AltInventory/Resources/IconBorder.tga");
	self.IconBorder:SetMouseVisible(false);
	self.IconBorder:SetVisible((itemInfo==nil));
	self.Qty=Turbine.UI.Label();
	self.Qty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.Qty:SetForeColor(Turbine.UI.Color.White)
	self.Qty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.Qty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.Qty:SetMouseVisible(false);
	self.Qty:SetText(qty)
	self.Name=name;
	self.Category=accountItemQty[name].Category;
	self.SortCategory=accountItemQty[name].SortCategory;
	if self.SortCategory==nil then self.SortCategory=self.Category end;
	self.Quality=accountItemQty[name].Quality;
	local filterHeight=inventoryPanel.EntryNormalHeight
	local cmpText=string.lower(string.stripaccent(inventoryPanel.SearchText.Text));
	self.ForceSort=1;
	local category=inventoryPanel.FilterList:GetValue()
	if category~=-1 and self.Category~=category then
		filterHeight=0;
		self.ForceSort=2;
	elseif inventoryPanel.SearchText.Text~="" then
		if string.find(string.lower(string.stripaccent(self.Name)),cmpText)==nil then
			filterHeight=0;
			self.ForceSort=2;
		end
	end
--	if char==charName or char=="Shared Storage" or char==charName.." (Vault)" and not Settings.totalsOnly then
	if char==charName and not Settings.totalsOnly then
		self.Item=Turbine.UI.Lotro.ItemControl()
		self.Item:SetParent(self.IconBack);
		self.Item:SetSize(36,36);
		self.Item:SetPosition(-3,-3);
		self.ItemInfo:SetVisible(false);
		self.Icon:SetVisible(false);
		self.Item:SetAllowDrop(true);
		self.Item.DragDrop=function(sender,args)
			if Settings.debug then
				Table.Dump(args)
			end
			backPack:PerformShortcutDrop(args.DragDropInfo:GetShortcut(),self.Item.Index);
		end
	else
		self.IconBack:SetBackground(accountItemQty[name].BackgroundImageID);
	end
	if Settings.panelViewMode==3 then
		-- icon only
		self:SetSize(inventoryPanel.EntryNormalHeight,filterHeight);
		self.Back:SetSize(inventoryPanel.EntryNormalHeight-4,inventoryPanel.EntryNormalHeight-4);
		self.Text:SetSize(inventoryPanel.EntryNormalWidth-38,inventoryPanel.EntryNormalHeight-4);
		self.Text:SetPosition(34,1);
		self.Text:SetVisible(false);
		self.IconBack:SetPosition(1,1);
		self.IconBack:SetVisible(true);
		self.Qty:SetParent(self.Icon);
		self.Qty:SetSize(28,12);
		self.Qty:SetTop(16);
		if qty<10000 then
			self.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		else
			self.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana10);
		end
	elseif Settings.panelViewMode==2 then
		-- icon and text
		self:SetSize(inventoryPanel.EntryNormalWidth,filterHeight);
		self.Back:SetSize(inventoryPanel.EntryNormalWidth-4,inventoryPanel.EntryNormalHeight-4);
		self.Text:SetSize(inventoryPanel.EntryNormalWidth-38,inventoryPanel.EntryNormalHeight-4);
		self.Text:SetPosition(34,1);
		self.Text:SetVisible(true);
		self.IconBack:SetPosition(1,1);
		self.IconBack:SetVisible(true);
		self.Qty:SetParent(self.Icon);
		self.Qty:SetSize(28,12);
		self.Qty:SetTop(16);
		if qty<10000 then
			self.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		else
			self.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana10);
		end
	else
		-- text only
		self:SetSize(inventoryPanel.EntryWideWidth,filterHeight);
		self.Back:SetSize(inventoryPanel.EntryWideWidth-4,self:GetHeight()-4);
		self.Text:SetSize(inventoryPanel.EntryWideWidth-58,self:GetHeight()-4);
		self.Text:SetPosition(54,1);
		self.Text:SetVisible(true);
		self.IconBack:SetPosition(1,1);
		self.IconBack:SetVisible(false);
		self.Qty:SetParent(self.Back);
		self.Qty:SetSize(48,self.Text:GetHeight());
		self.Qty:SetTop(1);
		self.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		self.Qty:SetText(qty)
	end
	if char~=charName or Settings.totalsOnly then
		self.MouseHover=function()
			-- remove prior items
			local detailList=qtyDetail:GetItems();
			detailList:Clear();
			local tmpList={};
--*** this is where we create the popup list of quantities
			if inventoryWindow.CharList:GetSelectedIndex()==1 then
				for k,v in pairs(accountItemQty[self.Name].Qty) do
					if k~="Shared Storage" then
						table.insert(tmpList,tostring(k)..": "..tostring(v.Subtotal));
					end
				end
				table.sort(tmpList)
				if accountItemQty[self.Name].Qty["Shared Storage"]~=nil then
					table.insert(tmpList,1,tostring("Shared Storage")..": "..tostring(accountItemQty[self.Name].Qty["Shared Storage"].Subtotal));
				end
			elseif inventoryWindow.CharList:GetSelectedIndex()==2 then
				for k,v in pairs(accountItemQty[self.Name].Qty["Shared Storage"]) do
					if k~="Subtotal" then
						table.insert(tmpList,tostring(sharedStorage:GetChestName(k))..": "..tostring(v))
					end
				end
				table.sort(tmpList)
			elseif inventoryWindow.CharList:GetText()==charName then
				-- calculate and display bag totals
				local bagQty={}
				for k,v in pairs(accountItemQty[self.Name].Qty[charName]) do
					if k~="Subtotal" then
--*** this calculation is flawed now that bags are variable size
--*** there is no bag property for backpack items like the chest property for vault items :(
						local bag=math.floor((k+14)/15)
						if bagQty[bag]==nil then
							bagQty[bag]=v;
						else
							bagQty[bag]=bagQty[bag]+v;
						end
					end
				end
				for k,v in pairs(bagQty) do
					table.insert(tmpList,Resource[language][49]..tostring(k)..": "..tostring(v));
				end
			else
				local char=string.match(inventoryWindow.CharList:GetText(),"(.*) %(Vault%)")
				local isVault=true;
				if char==nil then
					char=inventoryWindow.CharList:GetText();
					isVault=false;
				end
				
				for k,v in pairs(accountItemQty[self.Name].Qty[inventoryWindow.CharList:GetText()]) do
					if k~="Subtotal" then
						if isVault then
							if char==charName then
								table.insert(tmpList,tostring(vault:GetChestName(k))..": "..tostring(v));
							else
								table.insert(tmpList,tostring(CharList[char].VaultChestNames[k+1])..": "..tostring(v));
							end
						else
							table.insert(tmpList,Resource[language][49]..tostring(k)..": "..tostring(v));
						end
					end
				end
				table.sort(tmpList)
			end
			for k,v in ipairs(tmpList) do
				detailList:Add(Turbine.UI.MenuItem(v));
			end
			qtyDetail:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20);
		end
		self.MouseLeave=function()
			qtyDetail:Close();
		end
	end
end
inventoryPanel.Refresh=function()
	local selCharName;
	if inventoryWindow.CharList:GetSelectedIndex()==1 then
		selCharName="ALL";
	elseif inventoryWindow.CharList:GetSelectedIndex()==2 then
		selCharName="Shared Storage";
	else
		selCharName=inventoryWindow.CharList:GetText();
	end

	inventoryPanel.ItemList:ClearItems();

	local filterIndex;

	for filterIndex=2,inventoryPanel.FilterList.ListData:GetItemCount() do
		inventoryPanel.FilterList:HideEntry(filterIndex);
	end

	local showUndefined=false;

	-- populate inventoryPanel.ItemList
	for k,v in pairs(accountItemQty) do
		for filterIndex=2,inventoryPanel.FilterList.ListData:GetItemCount() do
			if v.Category==inventoryPanel.FilterList.ListData:GetItem(filterIndex).DataValue and (inventoryWindow.CharList:GetSelectedIndex()==1 or v.Qty[inventoryWindow.CharList:GetText()]~=nil) then
				inventoryPanel.FilterList:ShowEntry(filterIndex);
				break;
			end
		end
		if v.SortCategory==Turbine.Gameplay.ItemCategory.Undefined then
			showUndefined=true;
		end
		if v.ListItem==nil then v.ListItem={} end;
		if selCharName=="ALL" then
			local tmpEntry=ItemEntry(k,"ALL",v.Total,v.ItemInfo);
			v.ListItem["ALL"]=tmpEntry;
			inventoryPanel.ItemList:AddItem(tmpEntry);
			if v.Qty[charName]~=nil then
				for char,qty in pairs(v.Qty) do
					if char==selCharName then
						local tmpEntry=ItemEntry(k,selCharName,qty.Subtotal,v.ItemInfo);
						v.ListItem[selCharName]=tmpEntry;
						inventoryPanel.ItemList:AddItem(tmpEntry);
					else
						v.ListItem[char]=nil;
					end
				end
			end
		elseif selCharName==charName and not Settings.totalsOnly then
			v.ListItem["ALL"]=nil;
			if selCharName==charName and v.ListItem[charName]==nil then v.ListItem[charName]={} end
			if v.Qty[selCharName]~=nil then
				for char,qty in pairs(v.Qty) do
					if char==selCharName then
						v.ListItem[selCharName]={};
						for index,qty2 in pairs(qty) do
							if index~="Subtotal" then
								local tmpEntry=ItemEntry(k,selCharName,qty2,v.ItemInfo);
								tmpEntry.Item:SetItem(backPack:GetItem(index))
								v.ListItem[selCharName][index]=tmpEntry;
								tmpEntry.Item.Index=index;
								inventoryPanel.ItemList:AddItem(tmpEntry);
							end
						end
					else
						v.ListItem[char]=nil;
					end
				end
			end
		else
			if v.ListItem[selCharName]~=nil and v.ListItem[selCharName].IconBack==nil then v.ListItem[selCharName]=nil end; -- Settings.totalsOnly was previously on
			v.ListItem["ALL"]=nil;
			if v.Qty[selCharName]~=nil then
				for char,qty in pairs(v.Qty) do
					if char==selCharName then
						local tmpEntry
						if type(qty)=="table" then
							tmpEntry=ItemEntry(k,selCharName,qty.Subtotal,v.ItemInfo);
						else
							tmpEntry=ItemEntry(k,selCharName,qty,v.ItemInfo);
						end
						v.ListItem[selCharName]=tmpEntry;
						inventoryPanel.ItemList:AddItem(tmpEntry);
					else
						v.ListItem[char]=nil;
					end
				end
			end
		end
	end
	if showUndefined then
		-- the item category was not found, show the Undefined entry
		inventoryPanel.FilterList:ShowEntry(undefinedCategoryIndex);
	end
	inventoryPanel.SortList:SelectedIndexChanged(); -- apply sort
end

--*************************************************** Equipped Items panel *************
equipmentWearColor={}
equipmentWearColor[Turbine.Gameplay.ItemWearState.Undefined]=Turbine.UI.Color.Grey
equipmentWearColor[Turbine.Gameplay.ItemWearState.Damaged]=Turbine.UI.Color.Yellow
equipmentWearColor[Turbine.Gameplay.ItemWearState.Pristine]=Turbine.UI.Color.Green
equipmentWearColor[Turbine.Gameplay.ItemWearState.Broken]=Turbine.UI.Color.Red
equipmentWearColor[Turbine.Gameplay.ItemWearState.Worn]=Turbine.UI.Color.LightGreen

equipmentLayout={}
equipmentLayout[0]={0,0} -- mannequin centered
equipmentLayout[0].background=0x41007e95;
equipmentLayout[0].Text="Mannequin";
equipmentLayout[0].Class=Turbine.Gameplay.Equipment.Undefined; -- should be same as index...
equipmentLayout[1]={119,-30} -- orig 149
equipmentLayout[1].background=0x41007eed;
equipmentLayout[1].Text="Head Slot";
equipmentLayout[1].Class=Turbine.Gameplay.Equipment.Head;
equipmentLayout[2]={119,16};
equipmentLayout[2].background=0x41007ef0;
equipmentLayout[2].Text="Chest Slot";
equipmentLayout[2].Class=Turbine.Gameplay.Equipment.Chest;
equipmentLayout[3]={119,108};
equipmentLayout[3].background=0x41007ef1;
equipmentLayout[3].Text="Legs Slot";
equipmentLayout[3].Class=Turbine.Gameplay.Equipment.Legs;
equipmentLayout[4]={119,62};
equipmentLayout[4].background=0x41007ef2;
equipmentLayout[4].Text="Gloves Slot";
equipmentLayout[4].Class=Turbine.Gameplay.Equipment.Gloves;
equipmentLayout[5]={163,108};
equipmentLayout[5].background=0x41007ef5;
equipmentLayout[5].Text="Boots Slot";
equipmentLayout[5].Class=Turbine.Gameplay.Equipment.Boots;
equipmentLayout[6]={163,-30} -- orig 203
equipmentLayout[6].background=0x41007eee;
equipmentLayout[6].Text="Shoulder Slot";
equipmentLayout[6].Class=Turbine.Gameplay.Equipment.Shoulder;
equipmentLayout[7]={163,16}
equipmentLayout[7].background=0x41007ee9;
equipmentLayout[7].Text="Back Slot";
equipmentLayout[7].Class=Turbine.Gameplay.Equipment.Back;
equipmentLayout[8]={-98,62};
equipmentLayout[8].background=0x41007ef8;
equipmentLayout[8].Text="Left Bracelet Slot";
equipmentLayout[8].Class=Turbine.Gameplay.Equipment.Bracelet1;
equipmentLayout[9]={-54,62};
equipmentLayout[9].background=0x41007ef9;
equipmentLayout[9].Text="Right Bracelet Slot";
equipmentLayout[9].Class=Turbine.Gameplay.Equipment.Bracelet2;
equipmentLayout[10]={-98,16};
equipmentLayout[10].background=0x41007eef;
equipmentLayout[10].Text="Necklace Slot";
equipmentLayout[10].Class=Turbine.Gameplay.Equipment.Necklace;
equipmentLayout[11]={-98,108};
equipmentLayout[11].background=0x41007ef3;
equipmentLayout[11].Text="Left Ring Slot";
equipmentLayout[11].Class=Turbine.Gameplay.Equipment.Ring1;
equipmentLayout[12]={-54,108};
equipmentLayout[12].background=0x41007ef4;
equipmentLayout[12].Text="Right Ring Slot";
equipmentLayout[12].Class=Turbine.Gameplay.Equipment.Ring2;
equipmentLayout[13]={-98,-30} -- orig -138
equipmentLayout[13].background=0x41007ef6;
equipmentLayout[13].Text="Left Ear Slot";
equipmentLayout[13].Class=Turbine.Gameplay.Equipment.Earring1;
equipmentLayout[14]={-54,-30} --orig -84 
equipmentLayout[14].background=0x41007ef7;
equipmentLayout[14].Text="Right Ear Slot";
equipmentLayout[14].Class=Turbine.Gameplay.Equipment.Earring2;
equipmentLayout[15]={-54,16};
equipmentLayout[15].background=0x41007efa;
equipmentLayout[15].Text="Pocket Slot";
equipmentLayout[15].Class=Turbine.Gameplay.Equipment.Pocket;
equipmentLayout[16]={-74,157};
equipmentLayout[16].background=0x41007eea;
equipmentLayout[16].Text="Primary Weapon Slot";
equipmentLayout[16].Class=Turbine.Gameplay.Equipment.PrimaryWeapon;
equipmentLayout[17]={-20,157};
equipmentLayout[17].background=0x41007eeb;
equipmentLayout[17].Text="Secondary Weapon/Shield Slot";
equipmentLayout[17].Class=Turbine.Gameplay.Equipment.SecondaryWeapon;
equipmentLayout[18]={34,157};
equipmentLayout[18].background=0x41007eec;
equipmentLayout[18].Text="Ranged Weapon/Instrument Slot";
equipmentLayout[18].Class=Turbine.Gameplay.Equipment.RangedWeapon;
equipmentLayout[19]={88,157};
equipmentLayout[19].background=0x41007efb;
equipmentLayout[19].Text="Craft Slot";
equipmentLayout[19].Class=Turbine.Gameplay.Equipment.CraftTool;
equipmentLayout[20]={142,157};
equipmentLayout[20].background=0x410e8680;
equipmentLayout[20].Text="Class Slot";
equipmentLayout[20].Class=Turbine.Gameplay.Equipment.Class;

equipmentPanel=Turbine.UI.Control()
equipmentPanel.Port=Turbine.UI.Control()
equipmentPanel.Port:SetParent(equipmentPanel)
equipmentPanel.Port:SetSize(301,252)
equipmentPanel.VScroll=Turbine.UI.Lotro.ScrollBar()
equipmentPanel.VScroll:SetParent(equipmentPanel)
equipmentPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
equipmentPanel.VScroll:SetMinimum(0)
equipmentPanel.HScroll=Turbine.UI.Lotro.ScrollBar()
equipmentPanel.HScroll:SetParent(equipmentPanel)
equipmentPanel.HScroll:SetOrientation(Turbine.UI.Orientation.Horizontal)
equipmentPanel.HScroll:SetMinimum(0)
do
	equipmentPanel:SetSize(Settings.panelWidth*displayWidth,Settings.panelHeight*displayHeight)
	equipmentPanel.Port:SetLeft(equipmentPanel:GetWidth()-equipmentPanel.Port:GetWidth())
	equipmentPanel.Port:SetTop(equipmentPanel:GetHeight()-equipmentPanel.Port:GetHeight())
	if equipmentPanel.Port:GetLeft()<0 then equipmentPanel.Port:SetLeft(0) end
	if equipmentPanel.Port:GetTop()<0 then equipmentPanel.Port:SetTop(0) end
	local left=(equipmentPanel.Port:GetWidth()-110)/2
	local top=(equipmentPanel.Port:GetHeight()-148)/2
	equipmentPanel.Mannequin=Turbine.UI.Control()
	equipmentPanel.Mannequin:SetParent(equipmentPanel.Port)
	equipmentPanel.Mannequin:SetPosition(left,top) -- centered
	equipmentPanel.Mannequin:SetSize(110,148)
	equipmentPanel.Mannequin:SetBackColor(Turbine.UI.Color.Grey) -- will change as item gets defined
	equipmentPanel.Mannequin:SetBlendMode(4)
	equipmentPanel.Mannequin:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin:SetBackground(equipmentLayout[0].background)

	equipmentPanel.Mannequin.Head=Turbine.UI.Control();
	equipmentPanel.Mannequin.Head:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Head:SetPosition(0,0);
	equipmentPanel.Mannequin.Head:SetBackground(0x41007e96);
	equipmentPanel.Mannequin.Head:SetSize(110,148);
	equipmentPanel.Mannequin.Head:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Head:SetBlendMode(4);
	equipmentPanel.Mannequin.Head:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Head:SetStretchMode(1); -- assigning mode 1 or 3 allows the image to blend with it's backcolor but overlay the image below (it's color doesn't affect the compound image)
	equipmentPanel.Mannequin.Head:SetMouseVisible(false);

	equipmentPanel.Mannequin.Chest=Turbine.UI.Control();
	equipmentPanel.Mannequin.Chest:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Chest:SetPosition(0,0);
	equipmentPanel.Mannequin.Chest:SetBackground(0x41007e97);
	equipmentPanel.Mannequin.Chest:SetSize(110,148);
	equipmentPanel.Mannequin.Chest:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Chest:SetBlendMode(4);
	equipmentPanel.Mannequin.Chest:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Chest:SetStretchMode(1);
	equipmentPanel.Mannequin.Chest:SetMouseVisible(false);

	equipmentPanel.Mannequin.Legs=Turbine.UI.Control();
	equipmentPanel.Mannequin.Legs:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Legs:SetPosition(0,0);
	equipmentPanel.Mannequin.Legs:SetBackground(0x41007e98);
	equipmentPanel.Mannequin.Legs:SetSize(110,148);
	equipmentPanel.Mannequin.Legs:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Legs:SetBlendMode(4);
	equipmentPanel.Mannequin.Legs:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Legs:SetStretchMode(1);
	equipmentPanel.Mannequin.Legs:SetMouseVisible(false);

	equipmentPanel.Mannequin.Wrist=Turbine.UI.Control();
	equipmentPanel.Mannequin.Wrist:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Wrist:SetPosition(0,0);
	equipmentPanel.Mannequin.Wrist:SetBackground(0x41007e99);
	equipmentPanel.Mannequin.Wrist:SetSize(110,148);
	equipmentPanel.Mannequin.Wrist:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Wrist:SetBlendMode(4);
	equipmentPanel.Mannequin.Wrist:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Wrist:SetStretchMode(1);
	equipmentPanel.Mannequin.Wrist:SetMouseVisible(false);

	equipmentPanel.Mannequin.Boot=Turbine.UI.Control();
	equipmentPanel.Mannequin.Boot:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Boot:SetPosition(0,0);
	equipmentPanel.Mannequin.Boot:SetBackground(0x41007e9a);
	equipmentPanel.Mannequin.Boot:SetSize(110,148);
	equipmentPanel.Mannequin.Boot:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Boot:SetBlendMode(4);
	equipmentPanel.Mannequin.Boot:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Boot:SetStretchMode(1);
	equipmentPanel.Mannequin.Boot:SetMouseVisible(false);

	equipmentPanel.Mannequin.Cape=Turbine.UI.Control();
	equipmentPanel.Mannequin.Cape:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Cape:SetPosition(0,0);
	equipmentPanel.Mannequin.Cape:SetBackground(0x41007e9b);
	equipmentPanel.Mannequin.Cape:SetSize(110,148);
	equipmentPanel.Mannequin.Cape:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Cape:SetBlendMode(4);
	equipmentPanel.Mannequin.Cape:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Cape:SetStretchMode(1);
	equipmentPanel.Mannequin.Cape:SetMouseVisible(false);

	equipmentPanel.Mannequin.Shoulder=Turbine.UI.Control();
	equipmentPanel.Mannequin.Shoulder:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Shoulder:SetPosition(0,0);
	equipmentPanel.Mannequin.Shoulder:SetBackground(0x41007e9c);
	equipmentPanel.Mannequin.Shoulder:SetSize(110,148);
	equipmentPanel.Mannequin.Shoulder:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Shoulder:SetBlendMode(4);
	equipmentPanel.Mannequin.Shoulder:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Shoulder:SetStretchMode(1);
	equipmentPanel.Mannequin.Shoulder:SetMouseVisible(false);

	equipmentPanel.Mannequin.Main=Turbine.UI.Control();
	equipmentPanel.Mannequin.Main:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Main:SetPosition(0,0);
	equipmentPanel.Mannequin.Main:SetBackground(0x41007e9d);
	equipmentPanel.Mannequin.Main:SetSize(110,148);
	equipmentPanel.Mannequin.Main:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Main:SetBlendMode(4);
	equipmentPanel.Mannequin.Main:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Main:SetStretchMode(1);
	equipmentPanel.Mannequin.Main:SetMouseVisible(false);

	equipmentPanel.Mannequin.Secondary=Turbine.UI.Control();
	equipmentPanel.Mannequin.Secondary:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Secondary:SetPosition(0,0);
	equipmentPanel.Mannequin.Secondary:SetBackground(0x41007e9e);
	equipmentPanel.Mannequin.Secondary:SetSize(110,148);
	equipmentPanel.Mannequin.Secondary:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Secondary:SetBlendMode(4);
	equipmentPanel.Mannequin.Secondary:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Secondary:SetStretchMode(1);
	equipmentPanel.Mannequin.Secondary:SetMouseVisible(false);

	equipmentPanel.Mannequin.Ranged=Turbine.UI.Control();
	equipmentPanel.Mannequin.Ranged:SetParent(equipmentPanel.Mannequin);
	equipmentPanel.Mannequin.Ranged:SetPosition(0,0);
	equipmentPanel.Mannequin.Ranged:SetBackground(0x41007e9f);
	equipmentPanel.Mannequin.Ranged:SetSize(110,148);
	equipmentPanel.Mannequin.Ranged:SetBackColor(equipmentWearColor[0]);
	equipmentPanel.Mannequin.Ranged:SetBlendMode(4);
	equipmentPanel.Mannequin.Ranged:SetBackColorBlendMode(1); -- 6
	equipmentPanel.Mannequin.Ranged:SetStretchMode(1);
	equipmentPanel.Mannequin.Ranged:SetMouseVisible(false);

	equipmentPanel.Mannequin.Craft=Turbine.UI.Control()
	equipmentPanel.Mannequin.Craft:SetParent(equipmentPanel.Mannequin)
	equipmentPanel.Mannequin.Craft:SetPosition(0,0)
	equipmentPanel.Mannequin.Craft:SetBackground(0x41007ea0)
	equipmentPanel.Mannequin.Craft:SetSize(110,148)
	equipmentPanel.Mannequin.Craft:SetBackColor(equipmentWearColor[0])
	equipmentPanel.Mannequin.Craft:SetBlendMode(4)
	equipmentPanel.Mannequin.Craft:SetBackColorBlendMode(1) -- 6
	equipmentPanel.Mannequin.Craft:SetStretchMode(1)
	equipmentPanel.Mannequin.Craft:SetMouseVisible(false)

	equipmentPanel.Mannequin.ControlXref={}
	equipmentPanel.Mannequin.ControlXref[1]=equipmentPanel.Mannequin.Head
	equipmentPanel.Mannequin.ControlXref[2]=equipmentPanel.Mannequin.Chest
	equipmentPanel.Mannequin.ControlXref[3]=equipmentPanel.Mannequin.Legs
	equipmentPanel.Mannequin.ControlXref[4]=equipmentPanel.Mannequin.Wrist
	equipmentPanel.Mannequin.ControlXref[5]=equipmentPanel.Mannequin.Boot
	equipmentPanel.Mannequin.ControlXref[6]=equipmentPanel.Mannequin.Shoulder
	equipmentPanel.Mannequin.ControlXref[7]=equipmentPanel.Mannequin.Cape
--	equipmentPanel.Mannequin.ControlXref[8]=equipmentPanel.Mannequin. bracelet 1
--	equipmentPanel.Mannequin.ControlXref[9]=equipmentPanel.Mannequin. bracelet 2
--	equipmentPanel.Mannequin.ControlXref[10]=equipmentPanel.Mannequin. necklace
--	equipmentPanel.Mannequin.ControlXref[11]=equipmentPanel.Mannequin. ring 1
--	equipmentPanel.Mannequin.ControlXref[12]=equipmentPanel.Mannequin. ring 2
--	equipmentPanel.Mannequin.ControlXref[13]=equipmentPanel.Mannequin. earring 1
--	equipmentPanel.Mannequin.ControlXref[14]=equipmentPanel.Mannequin. earring 2
--	equipmentPanel.Mannequin.ControlXref[15]=equipmentPanel.Mannequin. pocket
	equipmentPanel.Mannequin.ControlXref[16]=equipmentPanel.Mannequin.Main
	equipmentPanel.Mannequin.ControlXref[17]=equipmentPanel.Mannequin.Secondary -- also shield
	equipmentPanel.Mannequin.ControlXref[18]=equipmentPanel.Mannequin.Ranged -- also instrument
	equipmentPanel.Mannequin.ControlXref[19]=equipmentPanel.Mannequin.Craft
--	equipmentPanel.Mannequin.ControlXref[20]=equipmentPanel.Mannequin. class item

	equipmentPanel.Popup=Turbine.UI.ContextMenu()
	equipmentPanel.Popup:GetItems():Add(Turbine.UI.MenuItem(""))
	equipmentPanel.Popup:GetItems():Get(1):SetEnabled(false)
	equipmentPanel.Popup:GetItems():Add(Turbine.UI.MenuItem(""))
	equipmentPanel.Popup:GetItems():Get(2):SetEnabled(false)
	equipmentPanel.ItemSlot={}
	equipmentPanel.EquipmentSlot={}
	for k=1,20 do
		equipmentPanel.ItemSlot[k]=Turbine.UI.Control()
		equipmentPanel.ItemSlot[k]:SetParent(equipmentPanel.Port)
		equipmentPanel.ItemSlot[k]:SetSize(44,44)
		equipmentPanel.ItemSlot[k]:SetPosition(left+equipmentLayout[k][1],top+equipmentLayout[k][2])
		equipmentPanel.ItemSlot[k]:SetBackColor(Turbine.UI.Color.Grey)
		equipmentPanel.ItemSlot[k]:SetBlendMode(4)
		equipmentPanel.ItemSlot[k]:SetBackColorBlendMode(1)
		equipmentPanel.ItemSlot[k]:SetBackground(equipmentLayout[k].background)

		equipmentPanel.ItemSlot[k].Icon=Turbine.UI.Control()
		equipmentPanel.ItemSlot[k].Icon:SetParent(equipmentPanel.ItemSlot[k])
		equipmentPanel.ItemSlot[k].Icon:SetSize(32,32)
		equipmentPanel.ItemSlot[k].Icon:SetPosition(6,6)
		equipmentPanel.ItemSlot[k].Icon:SetMouseVisible(true)
		equipmentPanel.ItemSlot[k].Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		equipmentPanel.ItemSlot[k].Icon.Name=""
		equipmentPanel.ItemSlot[k].Icon:SetVisible(false)
		equipmentPanel.ItemSlot[k].Icon.MouseHover=function(sender,args)
			equipmentPanel.Popup:GetItems():Get(1):SetText(sender.Name)
			if sender.Name~=sender.InfoName then
				equipmentPanel.Popup:GetItems():Get(2):SetText(sender.InfoName)
			else
				equipmentPanel.Popup:GetItems():Get(2):SetText("")
			end
			equipmentPanel.Popup:ShowMenu()
			-- show name as popup
		end
		equipmentPanel.ItemSlot[k].Icon.Image=Turbine.UI.Control()
		equipmentPanel.ItemSlot[k].Icon.Image:SetParent(equipmentPanel.ItemSlot[k].Icon)
		equipmentPanel.ItemSlot[k].Icon.Image:SetSize(32,32)
		equipmentPanel.ItemSlot[k].Icon.Image:SetPosition(0,0)
		equipmentPanel.ItemSlot[k].Icon.Image:SetMouseVisible(false)
		equipmentPanel.ItemSlot[k].Icon.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		equipmentPanel.ItemSlot[k].Icon.Image:SetVisible(true)

		equipmentPanel.EquipmentSlot[k]=Turbine.UI.Lotro.EquipmentSlot()
		equipmentPanel.EquipmentSlot[k]:SetParent(equipmentPanel.ItemSlot[k])
		equipmentPanel.EquipmentSlot[k]:SetSize(38,38)
		equipmentPanel.EquipmentSlot[k]:SetPosition(3,3)
		equipmentPanel.EquipmentSlot[k]:SetAllowDrop(true)
		equipmentPanel.EquipmentSlot[k]:SetMouseVisible(true)
		equipmentPanel.EquipmentSlot[k]:SetEquipmentSlot(k)
	end
end
equipmentPanel.VScroll.ValueChanged=function()
	equipmentPanel.Port:SetTop(0-equipmentPanel.VScroll:GetValue())
end
equipmentPanel.HScroll.ValueChanged=function()
	equipmentPanel.Port:SetLeft(0-equipmentPanel.HScroll:GetValue())
end

if Settings.useMinimalHeader then
	equipmentPanel:SetParent(minimalWindow)
	equipmentPanel:SetPosition(minimalWindow.LeftMargin,minimalWindow.TopMargin)
else
	equipmentPanel:SetParent(inventoryWindow)
	equipmentPanel:SetPosition(inventoryWindow.LeftMargin,inventoryWindow.TopMargin)
end
equipmentPanel.Refresh=function()
	local selCharName;
	if inventoryWindow.CharList:GetSelectedIndex()==1 then
		selCharName="ALL";
	elseif inventoryWindow.CharList:GetSelectedIndex()==2 then
		selCharName="Shared Storage";
	else
		selCharName=inventoryWindow.CharList:GetText();
	end
	-- don't try to refresh if we aren't showing and EI panel
	if string.find(selCharName,"(EI)")~=nil then
		local tmpCharName=string.gsub(selCharName," .(EI.)","")
		local ei
		if selCharName==charEIName then
			ei=localPlayer:GetEquipment()
		end
		-- redisplay icons
		for k=1,20 do
			equipmentPanel.EquipmentSlot[k]:SetVisible(selCharName==charEIName)
			equipmentPanel.ItemSlot[k].Icon:SetVisible(false)
			if selCharName~=charEIName then
				-- update icon and text in equipmentPanel.ItemSlot[k] from equippedItems[tmpCharName][k]
				local tmpItem
				if equippedItems[tmpCharName]~=nil then
					tmpItem=equippedItems[tmpCharName][k]
				end
				if tmpItem~=nil then
					equipmentPanel.ItemSlot[k].Icon.Name=tmpItem.Name
					equipmentPanel.ItemSlot[k].Icon.InfoName=tmpItem.InfoName
					equipmentPanel.ItemSlot[k].Icon:SetBackground(tmpItem.BackgroundImageID)
					equipmentPanel.ItemSlot[k].Icon.Image:SetBackground(tmpItem.IconImageID)
					equipmentPanel.ItemSlot[k].Icon:SetVisible(true)
					if equipmentPanel.Mannequin.ControlXref[k]~=nil then
						equipmentPanel.Mannequin.ControlXref[k]:SetBackColor(equipmentWearColor[tmpItem.WearState])
					end
				else
					if equipmentPanel.Mannequin.ControlXref[k]~=nil then
						equipmentPanel.Mannequin.ControlXref[k]:SetBackColor(equipmentWearColor[0])
					end
				end
			else
				-- just refresh mannequin
				if equipmentPanel.Mannequin.ControlXref[k]~=nil then
					tmpItem=ei:GetItem(k)
					if tmpItem~=nil then
						equipmentPanel.Mannequin.ControlXref[k]:SetBackColor(equipmentWearColor[tmpItem:GetWearState()])
					else
						equipmentPanel.Mannequin.ControlXref[k]:SetBackColor(equipmentWearColor[0])
					end
				end
			end
		end
	end
end

equipmentPanel.Layout=function()
	local parent=equipmentPanel:GetParent()
	local width,height
	if parent.LeftMargin~=nil then
		width=parent:GetWidth()-parent.LeftMargin*2
		height=parent:GetHeight()-parent.TopMargin-parent.BottomMargin
	else
		width=parent:GetWidth()
		height=parent:GetHeight()
	end
	-- re-layout controls
	local left=(width-110)/2
	local top=(height-148)/2
	equipmentPanel:SetSize(width,height)
	equipmentPanel.Port:SetPosition((width-equipmentPanel.Port:GetWidth())/2,(height-equipmentPanel.Port:GetHeight())/2)
	if equipmentPanel:GetWidth()<equipmentPanel.Port:GetWidth() then
		equipmentPanel.Port:SetLeft(0)
		equipmentPanel.HScroll:SetTop(equipmentPanel:GetHeight()-10)
		equipmentPanel.HScroll:SetWidth(equipmentPanel:GetWidth())
		equipmentPanel.HScroll:SetMaximum(equipmentPanel.Port:GetWidth()-equipmentPanel:GetWidth()+10)
		equipmentPanel.HScroll:SetValue(0)
		equipmentPanel.HScroll:SetVisible(true)
	else
		equipmentPanel.Port:SetLeft((width-equipmentPanel.Port:GetWidth())/2)
		equipmentPanel.HScroll:SetVisible(false)
	end
	if equipmentPanel:GetHeight()<equipmentPanel.Port:GetHeight() then
		equipmentPanel.Port:SetTop(0)
		equipmentPanel.VScroll:SetLeft(equipmentPanel:GetWidth()-10)
		equipmentPanel.VScroll:SetHeight(equipmentPanel:GetHeight())
		equipmentPanel.VScroll:SetMaximum(equipmentPanel.Port:GetHeight()-equipmentPanel:GetHeight()+10)
		equipmentPanel.VScroll:SetValue(0)
		equipmentPanel.VScroll:SetVisible(true)
	else
		equipmentPanel.Port:SetTop((height-equipmentPanel.Port:GetHeight())/2)
		equipmentPanel.VScroll:SetVisible(false)
	end
end
equipmentPanel:Layout()